
var gotDrawn=false;

function translatePoint(cTile,alt,size,rotation,cameraHeight,offset){
	var x=cTile.x,y=cTile.y;
	//reflect x,y based on rotation!
	switch(rotation){
		case 1:
			x=100-cTile.y-1;
			y=cTile.x;
			break;
		case 2:
			x=100-cTile.x-1;
			y=100-cTile.y-1;
			break;
		case 3:
			x=cTile.y;
			y=100-cTile.x-1;
			break;
	}

	return {x:(((y+x)/2)*(size/100))+offset.x,
			y:((((y==0?0:-y)+x)/2)*(size/100)*cameraHeight)-(alt*(size/100)*(1-((1-cameraHeight)/2)))+offset.y};
}

function findFurthest(camPos,points){
	var dist,maxDist=0,maxPt;/*Constant for max diagonal on building platform? */
	for(var i=0;i<points.length;i++){
		dist=Math.sqrt(Math.pow(camPos.x-points[i].x,2)+Math.pow(camPos.y-points[i].y,2));
		if(dist>maxDist){
			maxDist=dist;
			maxPt=points[i];
		}
	}
	return {dist:maxDist,point:maxPt};
}

function nextBox(building,rotation,cTile){
	var x=100,y=0, bDist, maxDist={dist:0,point:false}, bFar, cDist=1000;
	//reflect x,y based on rotation!
	switch(rotation){
		case 1: x=0; y=0; break;
		case 2: x=0; y=100; break;
		case 3: x=100; y=100; break;
	}
	if(cTile)
		cDist=Math.sqrt(Math.pow(x-cTile.x,2)+Math.pow(y-cTile.y,2));
		
	for(var b=0;b<building.boxes.length;b++){
		bDist=findFurthest({x:x,y:y},building.boxes[b].floors[0].bottom);
		//is this box closer than the last box as well as the furthest out so far?
		if(bDist.dist<cDist && bDist.dist>maxDist.dist){
			maxDist=bDist;
			bFar=b;
		}
	}
	return {boxInd:bFar,point:maxDist.point};
	
}
/* NOT Using this type of function does restrict boxes to 4 sides....
function sideOrder(building,boxInd,rotation,cSide){
	var x=100,y=0, bDist, maxDist={dist:0,point:false}, bFar, cDist=1000;
	//reflect x,y based on rotation!
	switch(rotation){
		case 1: x=0; y=0; break;
		case 2: x=0; y=100; break;
		case 3: x=100; y=100; break;
	}
	var cFlr=building.boxes[boxInd].floors[0];
	
	if(cSide)
		cDist=
	
	for(var s=0;s<cFlr.bottom.length;s++){
		
	}
}*/


/*TODO: fix this shit!
need to find borders of toDraw then place each point in order
can't just do it based on the maxes like this?
*/
/*function pointOrder(toDraw){
	var minVals=[false,false,false,false],
		minInds=[0,1,2,3];
	for(var i=0;i<4;i++){
		if(minVals[0]==false || 
			toDraw[i].x<minVals[0].x ||
			(toDraw[i].x==minVals[0].x && toDraw[i].y<minVals[0].y))
		{
			minInds[0]=i;
			minVals[0]=toDraw[i];
		}
		if(minVals[1]==false || 
			toDraw[i].y<minVals[1].y ||
			(toDraw[i].y==minVals[1].y && toDraw[i].x>minVals[1].x))
		{
			minInds[1]=i;
			minVals[1]=toDraw[i];
		}
		if(minVals[2]==false || 
			toDraw[i].y>minVals[2].y ||
			(toDraw[i].x==minVals[2].x && toDraw[i].y>minVals[2].y))
		{
			minInds[2]=i;
			minVals[2]=toDraw[i];
		}
		if(minVals[3]==false || 
			toDraw[i].x<minVals[3].x ||
			(toDraw[i].x==minVals[3].x && toDraw[i].y>minVals[3].y))
		{
			minInds[3]=i;
			minVals[3]=toDraw[i];
		}
	}
	return minInds;
}*/

//TODO: instead of looping down the list of sides, need a function to
//		figure out drawing z-order for sides (based on rotation)
//		i don't think it's that simple though....
function paintBuilding(context,building,size,rotation,cameraHeight,offset,extraRot){
	var cBox,cFlr,cSide,nSide,cPath,cAlt,
		doShadow,cClr,rS,rB,cShp,cShps,
		toDraw,cRepeat,cSpr,cSprs,cImg,
		imgHeight,imgWidth,skewAmt,yAdjust,
		maxY=0,signStretched,signPos,
		cSideEx,nSideEx,rSEx,ptOrder;
	//draw each box
	var b=false;
	while(b===false || b.point !==false){
		if(building.boxOrder){
			if(b===false) b=0; else b++;
			if(b>=building.boxes.length) b=false;
				else rB=building.boxOrder[rotation][b];
		}else{
			b=nextBox(building,rotation,(b!==false ? b.point : false));
			rB=b.boxInd;
		}
		
		
		if(b.point===false || b===false) break;
		
		cBox=building.boxes[rB];
		cAlt=cBox.alt;
		//draw each floor
		for(var f=0;f<cBox.floors.length;f++){
			cFlr=cBox.floors[f];
			cRepeat=(cFlr.repeat !==undefined ? cFlr.repeat : 1);
			//repeat drawing for each floor iteration
			for(var r=0;r<cRepeat;r++){
				//draw each side of this floor
				for(var s=0;s<cFlr.bottom.length;s++){
					rS=(s-rotation<0 ? s-rotation+4 : s-rotation);
					
					cSide={top: cFlr.top[rS], 
						   bottom: cFlr.bottom[rS]};
					nSide={top: cFlr.top[(rS+1<cFlr.bottom.length ? rS+1 : 0)], 
						   bottom: cFlr.bottom[(rS+1<cFlr.bottom.length ? rS+1 : 0)]};
					cPath=[translatePoint(cSide.top,cAlt+cFlr.height,size,rotation,cameraHeight,offset),
						   translatePoint(nSide.top,cAlt+cFlr.height,size,rotation,cameraHeight,offset),
						   translatePoint(nSide.bottom,cAlt,size,rotation,cameraHeight,offset),
						   translatePoint(cSide.bottom,cAlt,size,rotation,cameraHeight,offset)];
						   
					if(extraRot===undefined || extraRot==0){
						doShadow=(((cSide.bottom.x-nSide.bottom.x)<0 ? 1 : 0)+
								 ((cSide.bottom.y-nSide.bottom.y)<0 ? 1 : 0))/2;
						doShadow*=1+Math.abs((((cSide.bottom.x-cSide.top.x)+
									(nSide.bottom.x-nSide.top.x)+
									(cSide.bottom.y-cSide.top.y)+
									(nSide.bottom.y-nSide.top.y))
									/4)/cFlr.height);
					}else{
						rSEx=(rS+extraRot>3 ? rS+extraRot-4 : rS+extraRot);
					
						cSideEx={top: cFlr.top[rSEx], 
							   bottom: cFlr.bottom[rSEx]};
						nSideEx={top: cFlr.top[(rSEx+1<cFlr.bottom.length ? rSEx+1 : 0)], 
							   bottom: cFlr.bottom[(rSEx+1<cFlr.bottom.length ? rSEx+1 : 0)]};

						doShadow=(((cSideEx.bottom.x-nSideEx.bottom.x)<0 ? 1 : 0)+
								 ((cSideEx.bottom.y-nSideEx.bottom.y)<0 ? 1 : 0))/2;
						doShadow*=1+Math.abs((((cSideEx.bottom.x-cSideEx.top.x)+
									(nSideEx.bottom.x-nSideEx.top.x)+
									(cSideEx.bottom.y-cSideEx.top.y)+
									(nSideEx.bottom.y-nSideEx.top.y))
									/4)/cFlr.height);

					}
					if(cFlr.wallColor){
						//use this floor's color
						if(isArray(cFlr.wallColor[0]) && rS<cFlr.wallColor.length){
							//side specific coloring
							cClr=cFlr.wallColor[rS].clone();
						}else if(isArray(cFlr.wallColor[0])) {
							//no specific color for this wall,
							//revert to first side's color
							cClr=cFlr.wallColor[0].clone();
						}else{
							//not an array, 1 color for whole floor
							cClr=cFlr.wallColor.clone();
						}
					}else{
						//use box color
						cClr=cBox.wallColor.clone();
					}
					if(doShadow>0 && cBox.dontShadow!==true && cFlr.dontShadow!==true){
						cClr[0]*=doShadow;
						cClr[1]*=doShadow;
						cClr[2]*=doShadow;
					}
						
					
					drawPath(context,cPath,"rgba("+Math.round(cClr[0])+","+Math.round(cClr[1])+","+Math.round(cClr[2])+","+(cClr.length>3 ? cClr[3] : 1)+")");
					if(cPath[2].y>maxY) maxY=cPath[2].y;
					if(cPath[3].y>maxY) maxY=cPath[3].y;
				
					//draw each in array of squares/sprites
					if(cFlr.shapes && s<cFlr.shapes.length){
						cShps=cFlr.shapes[rS];
						for(var i=0;i<cShps.length;i++){
							cShp=cShps[i];
							if(cShp.src) loadImages([{id:cShp.src,src:cShp.src,noSel:true}]);
							//draw each instance
							for(var j=0;j<cShp.pos.length;j++){
								toDraw=cPath.clone();
								//ptOrder=pointOrder(toDraw);
								//console.log(ptOrder);
								//console.log(toDraw);
								//code to use new pointOrder
								/*toDraw=[
									inBetweenPts(inBetweenPts(toDraw[ptOrder[0]],toDraw[ptOrder[1]],cShp.pos[j]),
												 inBetweenPts(toDraw[ptOrder[3]],toDraw[ptOrder[2]],cShp.pos[j]),
												 1-(cShp.height+cShp.alt)),
									inBetweenPts(inBetweenPts(toDraw[ptOrder[0]],toDraw[ptOrder[1]],cShp.pos[j]+cShp.width),
												 inBetweenPts(toDraw[ptOrder[3]],toDraw[ptOrder[2]],cShp.pos[j]+cShp.width),
												 1-(cShp.height+cShp.alt)),
									inBetweenPts(inBetweenPts(toDraw[ptOrder[0]],toDraw[ptOrder[1]],cShp.pos[j]+cShp.width),
												 inBetweenPts(toDraw[ptOrder[3]],toDraw[ptOrder[2]],cShp.pos[j]+cShp.width),
												 1-cShp.alt),
									inBetweenPts(inBetweenPts(toDraw[ptOrder[0]],toDraw[ptOrder[1]],cShp.pos[j]),
												 inBetweenPts(toDraw[ptOrder[3]],toDraw[ptOrder[2]],cShp.pos[j]),
												 1-cShp.alt)
									];
								*/
								//old style code
								switch(s){
									case 2: case 3:
									toDraw=[
											inBetweenPts(inBetweenPts(toDraw[0],toDraw[1],cShp.pos[j]),
														 inBetweenPts(toDraw[3],toDraw[2],cShp.pos[j]),
														 1-(cShp.height+cShp.alt)),
											inBetweenPts(inBetweenPts(toDraw[0],toDraw[1],cShp.pos[j]+cShp.width),
														 inBetweenPts(toDraw[3],toDraw[2],cShp.pos[j]+cShp.width),
														 1-(cShp.height+cShp.alt)),
											inBetweenPts(inBetweenPts(toDraw[0],toDraw[1],cShp.pos[j]+cShp.width),
														 inBetweenPts(toDraw[3],toDraw[2],cShp.pos[j]+cShp.width),
														 1-cShp.alt),
											inBetweenPts(inBetweenPts(toDraw[0],toDraw[1],cShp.pos[j]),
														 inBetweenPts(toDraw[3],toDraw[2],cShp.pos[j]),
														 1-cShp.alt)
											];
									break;
									case 0: case 1:
									toDraw=[
											inBetweenPts(inBetweenPts(toDraw[1],toDraw[0],cShp.pos[j]),
														 inBetweenPts(toDraw[2],toDraw[3],cShp.pos[j]),
														 1-(cShp.height+cShp.alt)),
											inBetweenPts(inBetweenPts(toDraw[1],toDraw[0],cShp.pos[j]+cShp.width),
														 inBetweenPts(toDraw[2],toDraw[3],cShp.pos[j]+cShp.width),
														 1-(cShp.height+cShp.alt)),
											inBetweenPts(inBetweenPts(toDraw[1],toDraw[0],cShp.pos[j]+cShp.width),
														 inBetweenPts(toDraw[2],toDraw[3],cShp.pos[j]+cShp.width),
														 1-cShp.alt),
											inBetweenPts(inBetweenPts(toDraw[1],toDraw[0],cShp.pos[j]),
														 inBetweenPts(toDraw[2],toDraw[3],cShp.pos[j]),
														 1-cShp.alt)
											];
									break;
								}
								if(cShp.src){
									//this is a sprite not a box!
									cImg=getImage(cShp.src);
									if(cImg.loaded){

									
										//Uncomment the following if you want to see a background
										//underneath where the image is supposed to be drawn
										//drawPath(context,toDraw,"rgb("+(40*rS)+",50,50)");
										
										signStretched=getImage(cShp.src+serializeSlope(toDraw));
										if(!signStretched){
											//make the image!
											stretchImage(cImg,toDraw,0,cShp.src+serializeSlope(toDraw),true)
											return false;
										}else{
											if(signStretched.loaded){
												//draw the image!
												signPos=lowestXY(toDraw);
												context.drawImage(signStretched,
																Math.round(signPos.x),
																Math.round(signPos.y),
																signStretched.width,
																signStretched.height);
											}else{
												return false;
											}
										}
										
									}else{
										return false;
									}
								}else{
									//just draw a box!
									cClr=cShp.fillColor.clone();
									if(doShadow>0 && cBox.dontShadow!==true){
										cClr[0]*=doShadow;
										cClr[1]*=doShadow;
										cClr[2]*=doShadow;
									}
							
									drawPath(context,toDraw,"rgba("+Math.round(cClr[0])+","+Math.round(cClr[1])+","+Math.round(cClr[2])+","+(cClr.length>3 ? cClr[3] : 1)+")","rgba("+Math.round(cShp.borderColor[0])+","+Math.round(cShp.borderColor[1])+","+Math.round(cShp.borderColor[2])+","+(cShp.borderColor.length>3 ? cShp.borderColor[3] : 1)+")",cShp.borderWidth);
								}
							}
						}
					}
					
				}
				cAlt+=cFlr.height;
			}
		}
	}
	
	maxY=translatePoint({x:(rotation==1 || rotation==2 ? 0 : 100),y:(rotation==1 || rotation==0 ? 0 : 100)},0,size,rotation,cameraHeight,offset);
	return maxY.y;
}

function buildingHeight(building,zoom,cameraHeight){
	var cHeight=0,maxHeight=0,cRepeat;
	for(var b=0;b<building.boxes.length;b++){
		cHeight=0;
		for(var f=0;f<building.boxes[b].floors.length;f++){
			if(building.boxes[b].floors[f].height){
				cRepeat=(building.boxes[b].floors[f].repeat !==undefined ? building.boxes[b].floors[f].repeat : 1);
				//repeat drawing for each floor iteration
				for(var r=0;r<cRepeat;r++){
					cHeight+=building.boxes[b].floors[f].height;
				}
			}
		}
		if(cHeight>maxHeight) maxHeight=cHeight;
	}
	return (maxHeight*(zoom/100)*(1-((1-cameraHeight)/2)))+(zoom*cameraHeight);
}

function serializeParams(extraParams){
	var output="";
	if(extraParams!==undefined){
		for(var i=0;i<extraParams.length;i++){
			output+='&'+extraParams[i].id+'='+extraParams[i].src;
		}
	}
	return output;
}

function getExtraParam(extraParams,paramId){
	if(extraParams){
		for(var i=0;i<extraParams.length;i++){
			if(paramId==extraParams[i].id){
				return extraParams[i].src;
			}
		}
	}
	return undefined;
}

function makeBuildingSprite(building,size,rotation,cameraHeight,dontClear,extraParams){
	var paintResults,cShp,cFlr,
		serializedParams=serializeParams(extraParams),
		extraRot,finalRot;
	//dont let us overwrite anything
	building=building.clone();
	cameraHeight=Math.round(cameraHeight*100)/100;
	//don't do it again!
	if(getImage(building.id+serializedParams+"::"+rotation+"::"+cameraHeight)==false){
		if(!dontClear){
			gotDrawn=false;
		}
		if(!gotDrawn){

		
			//update the building to these extra params!
			if(extraParams!==undefined){
				
				
				for(var b=0;b<building.boxes.length;b++){
					//apply a custom color
					if(building.boxes[b].id!==undefined){
						for(var i=0;i<extraParams.length;i++){
							if(building.boxes[b].id==extraParams[i].id){
								building.boxes[b].wallColor=extraParams[i].src.split(',');
							}
						}
					}
					for(var f=0;f<building.boxes[b].floors.length;f++){
						if(building.boxes[b].floors[f].shapes){
							for(var side=0;side<building.boxes[b].floors[f].shapes.length;side++){
								for(var shp=0;shp<building.boxes[b].floors[f].shapes[side].length;shp++){
									cShp=building.boxes[b].floors[f].shapes[side][shp];
									
									//apply a custom sign
									if(cShp.id!==undefined){
										for(var i=0;i<extraParams.length;i++){
											if(cShp.id==extraParams[i].id){
												cShp.src=extraParams[i].src;
											}
										}
									}
								}
							}
						}
						cFlr=building.boxes[b].floors[f];
						//apply custom building floor count or floor color
						if(cFlr.id!==undefined || cFlr.colorID!==undefined){
							for(var i=0;i<extraParams.length;i++){
								if(cFlr.id==extraParams[i].id){
									cFlr.repeat=parseInt(extraParams[i].src);
								}
								if(cFlr.colorID==extraParams[i].id){
									cFlr.wallColor=extraParams[i].src.split(',');
								}
							}
						}
					}
				}
			}
			//rotation parameter 
			extraRot=getExtraParam(extraParams,"rotation");
			finalRot=rotation;
			if(extraRot!==undefined){
				extraRot=parseInt(extraRot);
				finalRot+=extraRot;
				if(finalRot>3) finalRot-=4;
				if(finalRot<0) finalRot+=4;
			}
			
			var canvas = document.createElement("canvas"),
				context = canvas.getContext("2d"),
				height = buildingHeight(building,size,cameraHeight);
			canvas.width=size;
			canvas.height=height;
			
			paintResults=paintBuilding(context,building,size,finalRot,cameraHeight,{x:0,y:height-(size*cameraHeight/2)},extraRot);
			
			if(paintResults===false){
				//free up memory
				delete canvas;
				//skewed images take some time to load so we may be waiting for a second...
				setTimeout(function(){makeBuildingSprite(building,size,rotation,cameraHeight,true,extraParams);},10);
			}else{
				gotDrawn=true;
			
				//save it!
				loadImages([{id:building.id+serializedParams+"::"+rotation+"::"+cameraHeight,
								 src:canvas.toDataURL()}]);
				
				//free up memory
				delete canvas;
				removeImages("buildingGen");
			
			}
		}
	}
	
	
}
