
/* 
TODO: what about a for rent/space available sign!?
< ... > denotes optional parameters

a building:
{id:'string',
 <src:'filepath',>
 size:integer,
 <groundImg:boolean,> //only if there is a src
 <neighbor: [],> //only if there is a groundImg, see below
 		Neighbor array contain objects as:
 		{rel:[],src:'filepath'}
 		rel being an array of possible neighbors in a binary string TODO: binary string?!?
 		tl-t-tr,l-c-r,bl-b,br (corners plus sides and the itself (itself is always 0))
 <onlyFlat:boolean,> //only allow building on flat ground
 <boxes: [],> //use instead of src or neighbors to generate a 3d building
 		Boxes array contain objects as:
 		{alt:integer, //floor altitude in pixels for this box
 		 <wallColor:[r,g,b<,a>],> //optional only if wallColors are specified on each floor
 		 <dontShadow:boolean,> //defaults to false when ommitted
 		 floors:[]
 		 	{bottom:[{x,y},...], //each point for a corner
 		 	 top:[{x,y},...],
 		 	 height:integer,
 		 	 <dontShadow:boolean,>
 		 	 <wallColor:[]> //rgb<a> array or array of rgb<a>'s for each side,
 		 	 <shapes:[]>
 		 	 	{pos:[x,...] //0-1 double proportation across where to paint
 		 	 	 alt:0-1 double
 		 	 	 height: 0-1 double
 		 	 	 <borderWidth: integer> //use these attributes to make a square
 		 	 	 <borderColor: [r,g,b<,a>]> //windows...doors...whatevers
 		 	 	 <fillColor: [r,g,b<,a>]>
 		 	 	 <src: 'filepath'> //or use an image!
<boxorder: []> //array of box indexes for each rotation (0-3) inside this array
 
 
*/
var buildings=[
			{id:'tree-1',
			 src:'img/tree.png',
			 size:1},
			{id:'cement',
			 src:'img/cement.jpg',
			 size:1,
			 groundImg:true, /*Ground image can only be used by itself: no boxes */
			 /*neighbor images to make roads connect together correctly (only on groundImg)
			 rel:tl-t-tr,l-c-r,bl-b,br TODO: can this be better? maybe some kind of wildcard?
			 perhaps...i could categorize all then make constants for each type*/
			 friends:['road'],
			 },
			{id:'road',
			 src:'img/road.png',
			 size:1,
			 allowBridges:true,
			 groundImg:true, /*Ground image can only be used by itself: no boxes */
			 /*neighbor images to make roads connect together correctly (only on groundImg)
			 rel:tl-t-tr,l-c-r,bl-b,br TODO: can this be better? maybe some kind of wildcard?
			 perhaps...i could categorize all then make constants for each type*/
			 friends:['cement'],
			 neighbor:[{rel:["000100000","000001000","000101000","100101000","100101100",
			 				 "001101001","001101000","000101001","000101100","101101100",
			 				 "101101001","001101101","100100000","000100100","000101101",
			 				 "101101101","101101000","100101101","001001001","000001001",
			 				 "100100100","001001000","100101001","001101100"],
			 			src:'img/road-ex.png'},
			 		   {rel:["010101010","010101000","000101010","010001010","010100010",
			 				 "010101001","100101010","010101101","001101010","001101010",
			 				 "101101010","101101010","010101100",
			 				 "010100011","110001010","010001110","011100011",
			 				 "011100010","110001110"],
			 			src:'img/road-inter.png'},
					   {rel:["000100010","100100010","100100011","000100011"],
			 			src:'img/road-corner1.png'},
					   {rel:["010100000","010100100","011100000","111100000"],
			 			src:'img/road-corner2.png'},
					   {rel:["010001000","010001001","110001000"],
			 			src:'img/road-corner3.png'},
					   {rel:["000001010","001001010"],
			 			src:'img/road-corner4.png'}
			 			],
			 bridgeSides:[
			 				{
			 				rel:"bridgeTileIndex!=0 && bridgeTileIndex!=bridgeLength-1",/*to be eval'd! TODO: is this a security problem? */
			 				height:1,/*height of image proportional to tileWidth=1*/
			 				vertOffset:0.4,
			 				src:"img/bridge-side.png",
			 				behindSrc:"img/bridge-side-2.png"
			 				},
			 				{
			 				rel:"bridgeTileIndex==0 || bridgeTileIndex==bridgeLength-1",
			 				height:1,
			 				vertOffset:0.1,
			 				src:"img/bridge-end.png"
			 				}

			 			]
			 },
			{id:'house-1',
			 size:2,
			 onlyFlat:true,
			 boxOrder: [
			 			[1,3,0,2],
			 			[0,1,2,3],
			 			[2,3,0,1],
			 			[3,2,1,0]
			 			],
			 boxes: [
			 			{
			 			alt: 0,
			 			wallColor: [220,190,220],
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:50,y:100},
				 							{x:50,y:50},
				 							{x:100,y:50}
				 							],
				 					top:	[
				 							{x:100,y:100},
				 							{x:50,y:100},
				 							{x:50,y:50},
				 							{x:100,y:50}
				 							],
				 					height: 35
				 					},
				 					{
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:50,y:100},
				 							{x:50,y:50},
				 							{x:100,y:50}
				 							],
				 					top:	[
				 							{x:75,y:75},
				 							{x:75,y:75},
				 							{x:75,y:75},
				 							{x:75,y:75}
				 							],
				 					height: 15
				 					}
			 					]
			 			},
			 			{
			 			alt: 0,
			 			wallColor: [220,220,190],
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:50,y:100},
				 							{x:0,y:100},
				 							{x:0,y:50},
				 							{x:50,y:50}
				 							],
				 					top:	[
				 							{x:50,y:100},
				 							{x:0,y:100},
				 							{x:0,y:50},
				 							{x:50,y:50}
				 							],
				 					height: 35
				 					},
				 					{
				 					bottom:	[
				 							{x:50,y:100},
				 							{x:0,y:100},
				 							{x:0,y:50},
				 							{x:50,y:50}
				 							],
				 					top:	[
				 							{x:25,y:75},
				 							{x:25,y:75},
				 							{x:25,y:75},
				 							{x:25,y:75}
				 							],
				 					height: 15
				 					}
			 					]
			 			},
			 			{
			 			alt: 0,
			 			wallColor: [190,220,220],
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:100,y:50},
				 							{x:50,y:50},
				 							{x:50,y:0},
				 							{x:100,y:0}
				 							],
				 					top:	[
				 							{x:100,y:50},
				 							{x:50,y:50},
				 							{x:50,y:0},
				 							{x:100,y:0}
				 							],
				 					height: 35
				 					},
				 					{
				 					bottom:	[
				 							{x:100,y:50},
				 							{x:50,y:50},
				 							{x:50,y:0},
				 							{x:100,y:0}
				 							],
				 					top:	[
				 							{x:75,y:25},
				 							{x:75,y:25},
				 							{x:75,y:25},
				 							{x:75,y:25}
				 							],
				 					height: 15
				 					}
			 					]
			 			},
			 			{
			 			alt: 0,
			 			wallColor: [190,190,220],
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:50,y:50},
				 							{x:0,y:50},
				 							{x:0,y:0},
				 							{x:50,y:0}
				 							],
				 					top:	[
				 							{x:50,y:50},
				 							{x:0,y:50},
				 							{x:0,y:0},
				 							{x:50,y:0}
				 							],
				 					height: 35
				 					},
				 					{
				 					bottom:	[
				 							{x:50,y:50},
				 							{x:0,y:50},
				 							{x:0,y:0},
				 							{x:50,y:0}
				 							],
				 					top:	[
				 							{x:25,y:25},
				 							{x:25,y:25},
				 							{x:25,y:25},
				 							{x:25,y:25}
				 							],
				 					height: 15
				 					}
			 					]
			 			}
					]
			},
			{id:'police',
			 size:3,
			 onlyFlat:true,
			 /*boxOrder:[/*one array for each rotation
			 			not required though, you can just
			 			let the program figure it out *//*
			 			in fact... this order breaks this building!
			 		   [2,1,0],
			 		   [2,1,0],
			 		   [2,1,0],
			 		   [2,1,0]
			 		  ],*/
			 boxes:	[
			   			{
			 			alt: 0,
			 			wallColor: [220,190,220],
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:70,y:100},
				 							{x:40,y:100},
				 							{x:40,y:70},
				 							{x:70,y:70}
				 							],
				 					top:	[
				 							{x:70,y:100},
				 							{x:40,y:100},
				 							{x:40,y:70},
				 							{x:70,y:70}
				 							],
				 					height: 35
				 					},
				 					{
				 					bottom:	[
				 							{x:40,y:70},
				 							{x:70,y:70},
				 							{x:70,y:100},
				 							{x:40,y:100}
				 							],
				 					top:	[
				 							{x:55,y:85},
				 							{x:55,y:85},
				 							{x:55,y:85},
				 							{x:55,y:85}
				 							],
				 					height: 15
				 					}
			 					]
			 			},
			  			{
			 			alt: 0,
			 			wallColor: [190,220,220],
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:70,y:100},
				 							{x:70,y:70},
				 							{x:100,y:70}
				 							],
				 					top:	[
				 							{x:100,y:100},
				 							{x:70,y:100},
				 							{x:70,y:70},
				 							{x:100,y:70}
				 							],
				 					height: 45
				 					},
				 					{
				 					bottom:	[
				 							{x:70,y:70},
				 							{x:100,y:70},
				 							{x:100,y:100},
				 							{x:70,y:100}
				 							],
				 					top:	[
				 							{x:80,y:80},
				 							{x:90,y:80},
				 							{x:90,y:90},
				 							{x:80,y:90}
				 							],
				 					height: 15
				 					},
				 					{
				 					top:	[
				 							{x:85,y:85},
				 							{x:85,y:85},
				 							{x:85,y:85},
				 							{x:85,y:85}
				 							],
				 					bottom:	[
				 							{x:80,y:80},
				 							{x:90,y:80},
				 							{x:90,y:90},
				 							{x:80,y:90}
				 							],
				 					height: 5
				 					}
			 					]
			 			},
						{
			 			alt: 0,
			 			wallColor: [220,220,190],
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:70,y:70},
				 							{x:10,y:70},
				 							{x:10,y:10},
				 							{x:70,y:10}
				 							],
				 					top:	[
				 							{x:70,y:70},
				 							{x:10,y:70},
				 							{x:10,y:10},
				 							{x:70,y:10}
				 							],
				 					shapes: [/*each side of the box*/
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									},
				 									{
				 									pos:[0.2,0.5],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.0,
				 									width:0.3,
				 									height:0.85,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								]
				 							],
				 					height: 45
				 					},
				 					{
				 					bottom:	[
				 							{x:70,y:70},
				 							{x:10,y:70},
				 							{x:10,y:10},
				 							{x:70,y:10}
				 							],
				 					top:	[
				 							{x:70,y:70},
				 							{x:10,y:70},
				 							{x:10,y:10},
				 							{x:70,y:10}
				 							],
				 					shapes: [/*each side of the box*/
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}/*,
				 									{
				 									pos:[0.05],
				 									alt:0.2,
				 									width:0.95,
				 									height:0.5,
				 									src:'img/police.png'
				 									}*/
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}/*,
				 									{
				 									pos:[0.05],
				 									alt:0.2,
				 									width:0.95,
				 									height:0.5,
				 									src:'img/police.png'
				 									}*/
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									},
				 									{
				 									pos:[0.05],
				 									alt:-0.2,
				 									width:0.95,
				 									height:0.5,
				 									id:'logo',
				 									src:'img/police.png'
				 									}
				 								]
				 							],
				 					height: 45
				 					},
				 					{
				 					id:		'floors',
				 					repeat:	0,
				 					bottom:	[
				 							{x:70,y:70},
				 							{x:10,y:70},
				 							{x:10,y:10},
				 							{x:70,y:10}
				 							],
				 					top:	[
				 							{x:70,y:70},
				 							{x:10,y:70},
				 							{x:10,y:10},
				 							{x:70,y:10}
				 							],
				 					shapes: [/*each side of the box*/
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}/*,
				 									{
				 									pos:[0.05],
				 									alt:0.2,
				 									width:0.95,
				 									height:0.5,
				 									src:'img/police.png'
				 									}*/
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}/*,
				 									{
				 									pos:[0.05],
				 									alt:0.2,
				 									width:0.95,
				 									height:0.5,
				 									src:'img/police.png'
				 									}*/
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.2,0.4,0.6,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								]
				 							],
				 					height: 45
				 					},
				 					{
				 					bottom:	[
				 							{x:70,y:70},
				 							{x:10,y:70},
				 							{x:10,y:10},
				 							{x:70,y:10}
				 							],
				 					top:	[
				 							{x:50,y:50},
				 							{x:30,y:50},
				 							{x:30,y:30},
				 							{x:50,y:30}
				 							],
				 					height: 15
				 					},
				 					{
				 					top:	[
				 							{x:40,y:40},
				 							{x:40,y:40},
				 							{x:40,y:40},
				 							{x:40,y:40}
				 							],
				 					bottom:	[
				 							{x:50,y:50},
				 							{x:30,y:50},
				 							{x:30,y:30},
				 							{x:50,y:30}
				 							],
				 					wallColor: [0,255,255,0.5],
				 					height:15
				 					}
			 					]
			 			}
			 		]
			},
			{id:'downtown-1',
			 size:1,
			 onlyFlat:true,
			 /*boxOrder: [
			 			[1,3,0,2],
			 			[0,1,2,3],
			 			[2,3,0,1],
			 			[3,2,1,0]
			 			],*/
			 boxes: [
			 			{
			 			alt: 0,
			 			wallColor: [220,190,220],
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:20,y:100},
				 							{x:20,y:0},
				 							{x:100,y:0}
				 							],
				 					top:	[
				 							{x:100,y:100},
				 							{x:20,y:100},
				 							{x:20,y:0},
				 							{x:100,y:0}
				 							],
				 					height: 65,
				 					wallColor: [[150,150,150],
				 								[200,200,200],
				 								[150,150,150],
				 								[150,150,150]],
				 					shapes: [/*each side of the box*/
				 								[],[/*an array of squares to paint*/
				 									{
				 									pos:[0,0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									},
				 									{
				 									pos:[0.2,0.5],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.0,
				 									width:0.3,
				 									height:0.85,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[],[
				 									{
				 									pos:[0.1],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.0,
				 									width:0.3,
				 									height:0.85,
				 									borderWidth:2,
				 									borderColor:[60,60,60],
				 									fillColor:[220,220,220]
				 									},
				 									{
				 									pos:[0.5],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.5,
				 									width:0.2,
				 									height:0.3,
				 									borderWidth:2,
				 									borderColor:[60,60,60],
				 									fillColor:[220,220,220]
				 									}
				 									]
				 							],
				 					},
				 					{
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:0,y:100},
				 							{x:0,y:0},
				 							{x:100,y:0}
				 							],
				 					top:	[
				 							{x:100,y:100},
				 							{x:0,y:100},
				 							{x:0,y:0},
				 							{x:100,y:0}
				 							],
				 					height: 25,
				 					wallColor: [[150,150,150],
				 								[255,255,255],
				 								[150,150,150],
				 								[150,150,150]],
				 					shapes: [
				 								[],[
				 									{
				 									pos:[0.05],
				 									alt:0,
				 									width:0.95,
				 									height:1,
				 									id:'logo',
				 									src:'img/school.png'
				 									}
				 								],[],[]
				 							]
				 					},
				 					{
				 					id:		'floors',
				 					repeat: 0,
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:10,y:100},
				 							{x:10,y:0},
				 							{x:100,y:0}
				 							],
				 					top:	[
				 							{x:100,y:100},
				 							{x:10,y:100},
				 							{x:10,y:0},
				 							{x:100,y:0}
				 							],
				 					height: 65,
				 					wallColor: [225,225,225],
				 					shapes: [/*each side of the box*/
				 								[
				 									{
				 									pos:[0.1,0.4,0.7],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0.1,0.4,0.7],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[
				 									{
				 									pos:[0.1,0.4,0.7],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[
				 									{
				 									pos:[0.1,0.4,0.7],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								]
				 							],
				 					},
				 					{
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:10,y:100},
				 							{x:10,y:0},
				 							{x:100,y:0}
				 							],
				 					top:	[
				 							{x:50,y:50},
				 							{x:50,y:50},
				 							{x:50,y:50},
				 							{x:50,y:50}
				 							],
				 					height: 0,
				 					dontShadow: true,
				 					wallColor: [40,40,40]
				 					}
			 					]
			 			},
			 			{
			 			alt: 0,
			 			wallColor: [150,150,150],
			 			dontShadow: true,
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:20,y:100},
				 							{x:0,y:100},
				 							{x:0,y:0},
				 							{x:20,y:0}
				 							],
				 					top:	[
				 							{x:10,y:50},
				 							{x:10,y:50},
				 							{x:10,y:50},
				 							{x:10,y:50}
				 							],
				 					height: 0
				 					}
			 					]
			 			}

			 		]
			 },
			 {id:'downtown-cornerstore-1',
			 size:1,
			 onlyFlat:true,
			 boxOrder: [
			 			[1,2,0],
			 			[1,2,0],
			 			[1,2,0],
			 			[1,2,0]
			 			],
			 boxes: [
			 			{
			 			alt: 0,
			 			wallColor: [220,190,220],
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:20,y:100},
				 							{x:20,y:20},
				 							{x:100,y:20}
				 							],
				 					top:	[
				 							{x:100,y:100},
				 							{x:20,y:100},
				 							{x:20,y:20},
				 							{x:100,y:20}
				 							],
				 					height: 65,
				 					wallColor: [[150,150,150],
				 								[200,200,200],
				 								[200,200,200],
				 								[150,150,150]],
				 					shapes: [/*each side of the box*/
				 								[],[/*an array of squares to paint*/
				 									{
				 									pos:[0.1],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.4,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									},
				 									{
				 									pos:[0.8],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									},
				 									{
				 									pos:[0.5],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.0,
				 									width:0.3,
				 									height:0.85,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[
				 									{
				 									pos:[0.5],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.5,
				 									height:0.7,
				 									id:'advert',
				 									src:'img/beer-glass.png'
				 									},
				 									{
				 									pos:[0],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									},
				 									{
				 									pos:[0.2],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.0,
				 									width:0.3,
				 									height:0.85,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[
				 									{
				 									pos:[0.1],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.0,
				 									width:0.3,
				 									height:0.85,
				 									borderWidth:2,
				 									borderColor:[60,60,60],
				 									fillColor:[220,220,220]
				 									},
				 									{
				 									pos:[0.5],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.5,
				 									width:0.2,
				 									height:0.3,
				 									borderWidth:2,
				 									borderColor:[60,60,60],
				 									fillColor:[220,220,220]
				 									}
				 									]
				 							],
				 					},
				 					{
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:0,y:100},
				 							{x:0,y:0},
				 							{x:100,y:0}
				 							],
				 					top:	[
				 							{x:100,y:100},
				 							{x:0,y:100},
				 							{x:0,y:0},
				 							{x:100,y:0}
				 							],
				 					height: 25,
				 					wallColor: [[150,150,150],
				 								[255,255,255],
				 								[255,255,255],
				 								[150,150,150]],
				 					shapes: [
				 								[],[
				 									{
				 									pos:[0.05],
				 									alt:0,
				 									width:0.90,
				 									height:1,
				 									id:'logo',
				 									src:'img/liquor.png'
				 									}
				 								],
				 								[
				 									{
				 									pos:[0.05],
				 									alt:0,
				 									width:0.90,
				 									height:1,
				 									id:'logo2',
				 									src:'img/beer-wine.png'
				 									}
				 								],[]
				 							]
				 					},
				 					{
				 					bottom:	[
				 							{x:10,y:100},
				 							{x:0,y:100},
				 							{x:0,y:0},
				 							{x:10,y:0}
				 							],
				 					top:	[
				 							{x:10,y:50},
				 							{x:10,y:50},
				 							{x:10,y:50},
				 							{x:10,y:50}
				 							],
				 					height: 0,
				 					wallColor: [200,200,200]
				 					},
				 					{
				 					id:		'floors',
				 					repeat: 0,
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:0,y:100},
				 							{x:0,y:0},
				 							{x:100,y:0}
				 							],
				 					top:	[
				 							{x:100,y:100},
				 							{x:0,y:100},
				 							{x:0,y:0},
				 							{x:100,y:0}
				 							],
				 					height: 65,
				 					wallColor: [225,225,225],
				 					shapes: [/*each side of the box*/
				 								[
				 									{
				 									pos:[0.1,0.4,0.7],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[/*an array of squares to paint*/
				 									{
				 									pos:[0.1,0.4,0.7],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[
				 									{
				 									pos:[0.1,0.4,0.7],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],
				 								[
				 									{
				 									pos:[0.1,0.4,0.7],/*pos array for multiple 
				 												instances of the same box */
				 									alt:0.25,
				 									width:0.2,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								]
				 							],
				 					},
				 					{
				 					bottom:	[
				 							{x:100,y:100},
				 							{x:0,y:100},
				 							{x:0,y:0},
				 							{x:100,y:0}
				 							],
				 					top:	[
				 							{x:50,y:50},
				 							{x:50,y:50},
				 							{x:50,y:50},
				 							{x:50,y:50}
				 							],
				 					height: 0,
				 					dontShadow: true,
				 					wallColor: [40,40,40],
				 					shapes: [
				 								[],[],
				 								[
				 									{
				 									pos:[0.2],
				 									alt:0.2,
				 									width:0.5,
				 									height:0.5,
				 									borderWidth:2,
				 									borderColor:[75,75,75],
				 									fillColor:[20,20,30]
				 									}
				 								],[]
				 							]
				 					}
			 					]
			 			},
			 			{
			 			alt: 0,
			 			wallColor: [150,150,150],
			 			dontShadow: true,
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:20,y:100},
				 							{x:0,y:100},
				 							{x:0,y:0},
				 							{x:20,y:0}
				 							],
				 					top:	[
				 							{x:10,y:50},
				 							{x:10,y:50},
				 							{x:10,y:50},
				 							{x:10,y:50}
				 							],
				 					height: 0
				 					}
			 					]
			 			},
			 			{
			 			alt: 0,
			 			wallColor: [150,150,150],
			 			dontShadow: true,
			 			floors:	[
				 					{
				 					bottom:	[
				 							{x:100,y:0},
				 							{x:20,y:0},
				 							{x:20,y:20},
				 							{x:100,y:20}
				 							],
				 					top:	[
				 							{x:60,y:10},
				 							{x:60,y:10},
				 							{x:60,y:10},
				 							{x:60,y:10}
				 							],
				 					height: 0
				 					}
			 					]
			 			}

			 		]
			 }
		];
	
