function getBuildingIndex(id){
	for(var i=0;i<buildings.length;i++){
		if(buildings[i].id==id) return i;
	};
	return false;
}

function getBuilding(id,map,x,y){
	var i=getBuildingIndex(id),
		itemID,userID,category,isPublic;
	if(i!==false && buildings[i].loaded!="loading"){
		if(buildings[i].loaded!==false){
			return buildings[i];
		}else{
			buildings[i].loaded="loading";
			itemID=buildings[i].itemID;
			userID=buildings[i].userID;
			category=buildings[i].category;
			isPublic=buildings[i].isPublic;
			//load from server instead
			loadItem(itemID,function(data){
				if(data){
					buildings[i]=eval('('+data+')');
					buildings[i].itemID=itemID;
					buildings[i].userID=userID;
					buildings[i].category=category;
					buildings[i].isPublic=isPublic;
					//build it if requested
					if(map!==undefined){
						placeBuilding(map,x,y,id);
					}
				}
			});
			return false;
		}
	}
	return false;
}

function suitableBuild(map,sel,onlyFlat,overWater,flagIfSuccess){
	var range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}},
		count=0,success=0;
	if(range.x.start<0 || range.y.start<0) return false;
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
			count++;
			if(map[x] && map[x][y] && (map[x][y].water==false || overWater) && (map[x][y].buildingId==false || map[x][y].buildingId==undefined)){
				if((onlyFlat===true && 
				   map[range.x.start][range.y.start].alt[0]==map[x][y].alt[1] &&
				   map[range.x.start][range.y.start].alt[0]==map[x][y].alt[2] &&
				   map[range.x.start][range.y.start].alt[0]==map[x][y].alt[3]) ||
				   !onlyFlat )
				{
					success++;
				}
			}
		}
	}
	if(count==success && count>0) {
		if(flagIfSuccess){
			for(var x=range.x.start; x<range.x.end+1; x++){
				for(var y=range.y.start; y<range.y.end+1; y++){
					map[x][y].buildingId={type:'placeholder',x:sel.a.x,y:sel.a.y,size:range.x.end-range.x.start+1};
				}
			}
			
		}
		return true;
	}
	return false;
		
}

/*TODO: error when making a bridge off the map! */
function findBridgeEdges(map,start,prevInd,count){
	var neighbors=findNeighbor(start,map[start.x][start.y].buildingId.type,map),
		edges=[],
		cEdge,
		dist;
	for(var i=1;i<neighbors.length;i+=2){
		if(neighbors[i]!==false){
			switch(i){
				case 1:
					dist=-1;cEdge=-1;
					while(cEdge<map[start.x-dist][start.y].water){
						dist++;
						cEdge=(map[start.x-dist][start.y].alt[0]+map[start.x-dist][start.y].alt[1])/2;
					}
					edges.push({side:i,alt:cEdge,count:dist});
					break;
				case 3:
					dist=-1;cEdge=-1;
					while(cEdge<map[start.x][start.y-dist].water){
						dist++;
						cEdge=(map[start.x][start.y-dist].alt[0]+map[start.x][start.y-dist].alt[3])/2;
					}
					edges.push({side:i,alt:cEdge,count:dist});
					break;
				case 5:
					dist=-1;cEdge=-1;
					while(cEdge<map[start.x][start.y+dist].water){
						dist++;
						cEdge=(map[start.x][start.y+dist].alt[2]+map[start.x][start.y+dist].alt[1])/2;
					}
					edges.push({side:i,alt:cEdge,count:dist});
					break;
				case 7:
					dist=-1;cEdge=-1;
					while(cEdge<map[start.x+dist][start.y].water){
						dist++;
						cEdge=(map[start.x+dist][start.y].alt[2]+map[start.x+dist][start.y].alt[3])/2;
					}
					edges.push({side:i,alt:cEdge,count:dist});
					break;
					
			}
		}


	}
	return edges;
}

function placeBuilding(map,x,y,id){
	var range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}},
		cBuilding=getBuilding(id,map,x,y),
		onlyFlat=cBuilding.onlyFlat,
		overWater=cBuilding.allowBridges,
		size=cBuilding.size,
		edges,weightedEdges;
				 
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
			if(suitableBuild(map,{a:{x:x,y:y},b:{x:x-(size-1),y:y-(size-1)}},onlyFlat,overWater,true)){
					map[x][y].buildingId={type:id};

			}
		}
	}
	//go back through and find teh edges
	if(overWater){
		for(var x=range.x.start; x<range.x.end+1; x++){
			for(var y=range.y.start; y<range.y.end+1; y++){
				if(map[x][y].buildingId.type==id && map[x][y].water!==false){
					//it's a bridge
					//find neighbors to look for the land side
					edges=findBridgeEdges(map,{x:x,y:y},-1,0);
					weightedEdges=[0,0,0,0];
					switch(edges[0].side){
						case 1:
							weightedEdges[0]=weightedEdges[1]=
								edges[0].alt+((edges[0].count)/
								(edges[0].count+edges[1].count+1)*
								(edges[1].alt-edges[0].alt));
							weightedEdges[2]=weightedEdges[3]=
								edges[0].alt+((edges[0].count+1)/
								(edges[0].count+edges[1].count+1)*
								(edges[1].alt-edges[0].alt));

							break;
						case 3:
							weightedEdges[0]=weightedEdges[3]=
								edges[0].alt+((edges[0].count)/
								(edges[0].count+edges[1].count+1)*
								(edges[1].alt-edges[0].alt));
							weightedEdges[2]=weightedEdges[1]=
								edges[0].alt+((edges[0].count+1)/
								(edges[0].count+edges[1].count+1)*
								(edges[1].alt-edges[0].alt));
							break;
					}
					map[x][y].bridgeAlt=weightedEdges;
					map[x][y].bridgeInd=edges[0].count;
					map[x][y].bridgeLength=edges[0].count+edges[1].count+1;
				}
			}
		}
	}
	selUpdated();
}

function removeBuilding(map,x,y){
	var cTile=map[x][y];
	if(cTile.buildingId){
		if(cTile.buildingId && cTile.buildingId.type=="placeholder"){
			x=cTile.buildingId.x;
			y=cTile.buildingId.y;
			cTile=map[x][y];
		}
		var bldInfo=getBuilding(cTile.buildingId.type);
		var range={x:{end:x,
					  start:x-(bldInfo.size-1)},
				   y:{end:y,
					  start:y-(bldInfo.size-1)}};
					 
		for(var x=range.x.start; x<range.x.end+1; x++){
			for(var y=range.y.start; y<range.y.end+1; y++){
				map[x][y].buildingId=false;
				if(map[x][y].bridgeAlt!==undefined) delete map[x][y].bridgeAlt;
				if(map[x][y].bridgeInd!==undefined) delete map[x][y].bridgeInd;
				if(map[x][y].bridgeLength!==undefined) delete map[x][y].bridgeLength;
				if(map[x][y].buildParams!==undefined) delete map[x][y].buildParams;
			}
		}
	}
}



function demolish(map,sel){
	var range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}};
				 
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
			removeBuilding(map,x,y);

			
		}
	}
	selUpdated();
}

function inParamArray(needle, haystack) {
	var length = haystack.length;
	for(var i = 0; i < length; i++) {
		if(haystack[i].id==needle) return i;
	}
	return false;
}


function setBuildingParam(map,x,y,id,src,rotation,cameraHeight){
	var cTile=map[x][y],
		cParam;
	if(cTile.buildingId){
		if(cTile.buildingId && cTile.buildingId.type=="placeholder"){
			x=cTile.buildingId.x;
			y=cTile.buildingId.y;
			cTile=map[x][y];
		}
		var bldInfo=getBuilding(cTile.buildingId.type);
			
		//create the array for param storage on tile
		if(map[x][y].buildParams===undefined)
			map[x][y].buildParams=[];
			
		//delete the old version of this param if needed
		if((cParam=inParamArray(id,map[x][y].buildParams))!==false)
			map[x][y].buildParams.remove(cParam);
			
		//add this param in the list
		if(src!='')
			map[x][y].buildParams.push({id:id,src:src});
			
		//generate a new image!
		makeBuildingSprite(bldInfo,100*bldInfo.size,rotation,cameraHeight,false,map[x][y].buildParams);
	}
}


function paramOnSel(map,sel,id,src,rotation,cameraHeight){
	var range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}};
				 
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
			setBuildingParam(map,x,y,id,src,rotation,cameraHeight);
		}
	}
	refresh(true);
}

function listAvailableParams(map,sel){
	var cTile,
		range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}};
				 
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
		
			//find this building
			cTile=map[x][y];
			if(cTile.buildingId && cTile.buildingId.type=="placeholder"){
				x=cTile.buildingId.x;
				y=cTile.buildingId.y;
				cTile=map[x][y];
			}
			if(cTile.buildingId){
				var building=getBuilding(cTile.buildingId.type),
					params=[],
					extraParams=cTile.buildParams || [],
					cVal='';
				if(!building){
					return [];
				}else{
					if(building.boxes){
						//rotation value
						cVal='0';
						for(var i=0;i<extraParams.length;i++){
							if(extraParams[i].id=='rotation'){
								cVal=extraParams[i].src;
							}
						}
						params.push({id:'rotation',type:'rotation',val:cVal});
						
						for(var b=0;b<building.boxes.length;b++){
							//apply a custom color
							if(building.boxes[b].id!==undefined && 
								!inArray(building.boxes[b].id,params,'id')){
								cVal='0,0,0,1';
								for(var i=0;i<extraParams.length;i++){
									if(building.boxes[b].id==extraParams[i].id){
										cVal=extraParams[i].src;
									}
								}
						
								params.push({id:building.boxes[b].id,type:'color',val:cVal});
							}
							for(var f=0;f<building.boxes[b].floors.length;f++){
								if(building.boxes[b].floors[f].shapes){
									for(var side=0;side<building.boxes[b].floors[f].shapes.length;side++){
										for(var shp=0;shp<building.boxes[b].floors[f].shapes[side].length;shp++){
											cShp=building.boxes[b].floors[f].shapes[side][shp];
									
											//apply a custom sign
											if(cShp.id!==undefined && 
												!inArray(cShp.id,params,'id')){
												cVal='';
												for(var i=0;i<extraParams.length;i++){
													if(cShp.id==extraParams[i].id){
														cVal=extraParams[i].src;
													}
												}
												params.push({id:cShp.id,type:'img',val:cVal});
											}
										}
									}
								}
								cFlr=building.boxes[b].floors[f];
								//apply custom building floor count or floor color
								if(cFlr.id!==undefined && 
									!inArray(cFlr.id,params,'id')){
									cVal='0';
									for(var i=0;i<extraParams.length;i++){
										if(cFlr.id==extraParams[i].id){
											cVal=extraParams[i].src;
										}
									}
									params.push({id:cFlr.id,type:'floors',val:cVal});
								}
								if(cFlr.colorID!==undefined && 
									!inArray(cFlr.colorID,params,'id')){
									cVal='0,0,0,1';
									for(var i=0;i<extraParams.length;i++){
										if(cFlr.colorID==extraParams[i].id){
											cVal=extraParams[i].src;
										}
									}
									params.push({id:cFlr.colorID,type:'color',val:cVal});
								}
							}
						}
					}
					return params;
				}
			}
			
		}
	}
	return [];
}
