
var cats=[];

function buildUL(catList,children,doLinks,root){

	function insertChildren(root){
		var output='';
		for(var i=0;i<children.length;i++){
			if(children[i].category==root){
				output+='<li data-id="'+children[i].itemID+'" data-owner="'+(children[i].userID==sessionID[1])+'" data-public="'+children[i].isPublic+'" class="item"><div class="itemRow"><a href="javascript:void(0);" class="childLink">'+children[i].id+'</a></div></li>';
			}
		}
		return output;
	};

	var output="";
	if(root===undefined) root=0;
	if(root) output+="<ul>";
	
	for(var i=0;i<catList.length;i++){
		if(catList[i].parent==root){
			output+='<li class="category" data-id="'+catList[i].id+'" data-created="'+catList[i].created+'" data-owner="'+(catList[i].userID==sessionID[1])+'"><div class="itemRow">'+
					(doLinks ? '<a href="javascript:void(0);" class="itemLink">' : '')+
					catList[i].name+'</div>'+
					(doLinks ? '</a>' : '')+
					buildUL(catList[i].children,children,doLinks,catList[i].id)+
					'</li>';
		}
	}
	output+=insertChildren(root);
	
	if(root) output+="</ul>";
	return output;
}


function buildUserUL(children,doLinks){

	function insertChildren(root){
		var output='';
		for(var i=0;i<children.length;i++){
			if(children[i].userID==root){
				output+='<li data-id="'+children[i].itemID+'" data-owner="'+(children[i].userID==sessionID[1])+'" data-public="'+children[i].isPublic+'" class="item"><div class="itemRow"><a href="javascript:void(0);" class="childLink">'+children[i].id+'</a></div></li>';
			}
		}
		return output;
	};

	var output="",inserted=[];
	
	for(var i=0;i<children.length;i++){
		if(!inArray(children[i].userID,inserted,true)){
			inserted.push(children[i].userID);
			output+='<li class="category user" data-id="'+children[i].userID+'" data-owner="'+(children[i].userID==sessionID[1])+'"><div class="itemRow">'+
					(doLinks ? '<a href="javascript:void(0);" class="itemLink">' : '')+
					children[i].username+'</div>'+
					(doLinks ? '</a>' : '')+
					'<ul>'+insertChildren(children[i].userID)+'</ul>'+
					'</li>';

		}
	}
	return output;
}

function buildOpts(catList,root,levels){
	var output="";
	if(root===undefined) root=0;
	if(levels===undefined) levels=1;
	if(root==0) output+='<option value="0">Root</option>';
	for(var i=0;i<catList.length;i++){
		if(catList[i].parent==root){
			output+='<option value="'+catList[i].id+'">'+
					repeatString('> ',levels)+
					catList[i].name+
					'</option>'+
					buildOpts(catList[i].children,catList[i].id,levels+1);
		}
	}
	return output;
}


function setMapList(){
	loadList(typeCity,function(data){
		maps=[];
		for(var i=0;i<data.length;i++){
			if(data[i].name){
				maps.push({id:data[i].name,
							itemID:data[i].id,
							category:data[i].category_id,
							userID:data[i].user_id,
							username:data[i].username,
							modified:data[i]['modified'],
							isPublic:data[i]['public']});
				
			}
		}


		loadCats(function(data){
			cats=data;

			//load categories into place
			var cityCats=catsOfType(typeCity);
			if($(".mapView").hasClass("byUser"))
				$('#maps').html(buildUserUL(maps,true));
			else $('#maps').html(buildUL(cityCats,maps,true));
			
			$("#mapMan select[name=category]").html(buildOpts(cityCats));

			$('#maps li.category>.itemRow>a').click(function(){
				$(this).parent().parent().toggleClass("expanded");
			});
			$('#maps li.item>.itemRow>a').click(function(){
				loadMap($(this).parent().parent().attr('data-id'));
			}).each(function(){
				var $this=$(this).parent().parent();
				if($this.attr('data-owner')=='true')
					$this.prepend('<a href="javascript:toggleMapPublic('+$this.attr('data-id')+')" class="ownerCtrl togglePublicItem '+($this.attr('data-public')=='1' ? 'public' : 'private')+'" title="Toggle Public">Toggle Public</a><a href="javascript:deleteMap('+$this.attr('data-id')+')" class="ownerCtrl delItem" title="Delete">Delete</a>');
			});

		});
					
	
	});
}

function loadBuildingList(){
	var buildingList="",bldManList="";
	
	loadList(typeBld,function(data){
			buildings=[];
			for(var i=0;i<data.length;i++){
				if(data[i].name){
					buildings.push({id:data[i].name,
									itemID:data[i].id,
									userID:data[i].user_id,
									username:data[i].username,
									category:data[i].category_id,
									loaded:false,
									modified:data[i]['modified'],
									isPublic:data[i]['public']});
					
					bldManList+='<li data-id="'+data[i].name+"\" class=\""+
								(data[i]['public']==0?'private ':'public ')+"\">"+data[i].name+' <small>(User: '+data[i].username+')</small><br>'+
								(data[i]['public']==0 ||
								 data[i]['user_id']==sessionID[1] ?
								"<a href=\"javascript:delBuilding('"+data[i].name+"');\">Delete</a> <a href=\"javascript:toggleBldPublic('"+data[i].name+"');\">Make "+(data[i]['public']==0?'Public':'Private')+"</a>":'')+
						" <a href=\"javascript:showBuildingConts('"+data[i].id+"');\">Load Contents</a> "+
						'</li>';
				}
			}
			$("#bldMan .current_bld ul").html(bldManList);
			
			//put it on the page in categories
			loadCats(function(data){
				cats=data;

				//load categories into place
				var bldCats=catsOfType(typeBld),
					bldCatOpts=buildOpts(bldCats);
				
				$("#bldMan select[name=category]").html(bldCatOpts);
				$("#mediaMan select[name=category]").html(bldCatOpts);
				
				
				if($(".bldView").hasClass("byUser"))
					$('#buildings').html(buildUserUL(buildings,true));
				else $('#buildings').html(buildUL(bldCats,buildings,true));
				
				//also put cats in the media man
				$('#media').html(buildUL(bldCats,[],true));
				$('#media li.category>.itemRow>a').click(function(){
					var $this=$(this).parent().parent();
					$this.toggleClass("expanded");
					if(!$this.hasClass("loaded")) loadMediaList($this.attr('data-id'));
				});
				$('#media li.category>.itemRow>a').each(function(){
					var $this=$(this).parent().parent();
					$(this).parent().prepend('<a href="javascript:loadMediaList('+$this.attr('data-id')+')" class="ownerCtrl loadMedia" title="Refresh Category">Refresh Category</a>');
				});

				//ok back the building list
				$('#buildings li.category>.itemRow>a').click(function(){
					$(this).parent().parent().toggleClass("expanded");
				});
				$('#buildings li.item>.itemRow>a').click(function(){
					insertBuilding($(this).html());
				}).each(function(){
					var $this=$(this).parent().parent();
					if($this.attr('data-owner')=='true')
						$this.prepend('<a href="javascript:toggleBldPublic('+$this.attr('data-id')+')" class="ownerCtrl togglePublicItem '+($this.attr('data-public')=='1' ? 'public' : 'private')+'" title="Toggle Public">Toggle Public</a><a href="javascript:deleteBuilding('+$this.attr('data-id')+')" class="ownerCtrl delItem" title="Delete">Delete</a>');
						
					$this.prepend('<a href="javascript:showBuildingConts('+$this.attr('data-id')+')" class="ownerCtrl inspectItem" title="Inspect Contents">Inspect Contents</a>');
				});
	
			});
			

	
	});
	

}


function loadBldCatList(){
	loadCats(function(data){
		cats=data;

		//load categories into place
		var bldCats=catsOfType(typeBld),
			cityCats=catsOfType(typeCity);
		
		$('#categories').html('<li class="category catType" data-type="2" data-id="0"><div class="itemRow"><a href="javascript:void(0);" class="itemLink">Buildings</a></div><ul>'+buildUL(bldCats,[],true)+'</ul></li><li class="category catType" data-type="1" data-id="0"><div class="itemRow"><a href="javascript:void(0);" class="itemLink">Maps</a></div><ul>'+buildUL(cityCats,[],true)+'</ul></li>').resizable();

		$('#categories li.category>.itemRow>a').click(function(){
			var $this=$(this).parent().parent();
			$("#categories").find(".selected").removeClass("selected");
			$this.toggleClass("expanded").addClass("selected");
			$("#insert_category_parent_id").val($this.attr("data-id"));
			$("#insert_category_type_id").val($this.closest(".catType").attr("data-type"));
		}).each(function(){
			var $this=$(this).parent().parent();
			if($this.attr('data-owner')=='true')
				$(this).parent().prepend('<a href="javascript:deleteCategory('+$this.attr('data-id')+')" class="ownerCtrl delItem" title="Delete">Delete</a>');
		});
		showDialog($("#catMan"));

	});
}

function loadMediaList(catID){
	loadList(typeMedia,function(data){
		var $li=$("#media").find("li[data-id="+catID+"]"),
			mediaItems=[],
			output='';
		$li.children("ul").children(".mediaItem").remove();
		for(var i=0;i<data.length;i++){
			if(data[i].name){
				mediaItems.push({id:data[i].name,
								itemID:data[i].id,
								userID:data[i].user_id,
								username:data[i].username,
								category:data[i].category_id,
								loaded:false,
								modified:data[i]['modified'],
								isPublic:data[i]['public']});
				output+='<li data-id="'+data[i].id+'" data-owner="'+(data[i].user_id==sessionID[1])+'" data-public="'+data[i]['public']+'" class="mediaItem"><div class="itemRow"><a href="javascript:deleteSprite('+data[i].id+')" class="ownerCtrl delItem" title="Delete">Delete</a><a href="javascript:previewSprite('+data[i].id+')" class="ownerCtrl inspectItem" title="Preview Image">Preview Image</a><a href="javascript:void(0);" class="itemLink">'+data[i].name+'</a><span class="id">'+data[i].id+'</span></div></li>';
			}
		}
		$li.children("ul").append(output);
	},catID);	
}

function reloadContent(){
	loadBuildingList();
	setMapList();
}


function catsOfType(type){
	for(var i=0;i<cats.length;i++){
		if(cats[i].type==type) return cats[i].children;
	}
	return false;
}

function loadMap(id){

	loadItem(id,function(data){
		if(data==="not logged in"){
			$("#mapMan").addClass("error").removeClass("loading")
				.find(".error_msg").html("Not Logged In");
		}else{
			map=JSON.parse(data);
			$("#mapMan").addClass("hidden").removeClass("loading");
			mapOffset={x:50,y:150};
			onLoad();
			
		}
	});
}

function deleteMap(id){

	deleteItem(id,function(data){
			if(data==="not logged in"){
				$("#mapMan").addClass("error").removeClass("loading")
					.find(".error_msg").html("Not Logged In");
			}else if(data==="invalid login"){
				$("#mapMan").addClass("error").removeClass("loading")
					.find(".error_msg").html("Invalid Login");
			}else{
				setMapList();
				
			}
	
	});
};

function deleteBuilding(id){

	deleteItem(id,function(data){
			if(data==="not logged in"){
				$("#bldMan").addClass("error").removeClass("loading")
					.find(".error_msg").html("Not Logged In");
			}else if(data==="invalid login"){
				$("#bldMan").addClass("error").removeClass("loading")
					.find(".error_msg").html("Invalid Login");
			}else{
				loadBuildingList();
				
			}
	
	});
};


function deleteSprite(id){

	deleteItem(id,function(data){
			if(data==="not logged in"){
				$("#mediaMan").addClass("error").removeClass("loading")
					.find(".error_msg").html("Not Logged In");
			}else if(data==="invalid login"){
				$("#mediaMan").addClass("error").removeClass("loading")
					.find(".error_msg").html("Invalid Login");
			}else{
				$("#media").find("li.mediaItem[data-id="+id+"]").remove();
				
			}
	
	});
};

function previewSprite(id){
	loadItem(id,function(data){
		$("#imgPreview .preview").html('<img src="'+data+'">');
		showDialog("#imgPreview");
	});
};


function toggleMapPublic(id){
	
	togglePublic(id,function(data){
			if(data==="not logged in"){
				$("#mapMan").addClass("error").removeClass("loading")
					.find(".error_msg").html("Not Logged In");
			}else if(data==="invalid login"){
				$("#mapMan").addClass("error").removeClass("loading")
					.find(".error_msg").html("Invalid Login");
			}else{
				setMapList();
				
			}
	
	});
}
function toggleBldPublic(id){

	togglePublic(id,function(data){
			if(data==="not logged in"){
				$("#bldMan").addClass("error").removeClass("loading")
					.find(".error_msg").html("Not Logged In");
			}else if(data==="invalid login"){
				$("#bldMan").addClass("error").removeClass("loading")
					.find(".error_msg").html("Invalid Login");
			}else{
				loadBuildingList();
				
			}
	
	});
}

function deleteCategory(id){
	deleteCat(id,function(){
		loadBldCatList();
		reloadContent();
	});
}

