/* TODO

	-agua -- still a slight alignment issue?
*/


//returns an array of the positions of the corners
function tilePos(x,y,alts,rotation,tileWidth,offset,cameraHeight,doWater,setAlt){
	var tileHeight=tileWidth*cameraHeight,
		altScale=tileWidth/6,
		output=[],
		cTile={x:x,y:y},
		mapSize={x:alts.length,y:alts[0].length};
		
		
	//if there's no water and we're looking for water, stop now
	if(doWater && !alts[cTile.x][cTile.y].water) return false;
	
	//reflect x,y based on rotation!
	switch(rotation){
		case 1:
			x=mapSize.y-cTile.y-1;
			y=cTile.x;
			break;
		case 2:
			x=mapSize.x-cTile.x-1;
			y=mapSize.y-cTile.y-1;
			break;
		case 3:
			x=cTile.y;
			y=mapSize.x-cTile.x-1;
			break;
	}
	
	
	//push each corner to the array
	for(var i=0;i<4;i++){
		var cRot=(i+rotation>3 ? i+rotation-4 : i+rotation),
			cAlt=alts[cTile.x][cTile.y].alt[cRot],
			cWater=alts[cTile.x][cTile.y].water,
			cX=(i>=2 ? x+1 : x),
			cY=(i==1 || i==2 ? y+1 : y);
			
		if(doWater){
			output.push({x:(((cY/2)+(cX/2))*tileWidth)+offset.x,
						 y:((((cY==0?0:-cY)/2)+(cX/2))*tileHeight)-(cWater*altScale)+offset.y});
		}else if(setAlt!==undefined){
			output.push({x:(((cY/2)+(cX/2))*tileWidth)+offset.x,
						 y:((((cY==0?0:-cY)/2)+(cX/2))*tileHeight)-(setAlt[cRot]*altScale)+offset.y});
			
		}else{
			output.push({x:(((cY/2)+(cX/2))*tileWidth)+offset.x,
						 y:((((cY==0?0:-cY)/2)+(cX/2))*tileHeight)-(cAlt*altScale)+offset.y});
		}
	}
	
	return output;
}

function groundColor(altitudes){
	//-5 grades=black,+10=white
	var slope=((altitudes[3]-altitudes[1])+(altitudes[0]-altitudes[2]))/2;
	var value=(slope+5)/15*255
	if(value<0) value=0;
	var avgAlt=(altitudes[0]+altitudes[1]+altitudes[2]+altitudes[3])/4
	
	//what color to make the tile?
	var r=90+(avgAlt/40*25);
	var g=130-(avgAlt/40*47);
	var b=68-(avgAlt/40*7);
	
	//apply shadow to the base color
	r=(r+value)/2;
	g=(g+value)/2;
	b=(b+value)/2;
	
	//make sure its valid
	r=(r>255 ? 255 : (r<0 ? 0 : r));
	g=(g>255 ? 255 : (g<0 ? 0 : g));
	b=(b>255 ? 255 : (b<0 ? 0 : b));
	
	//do some jank greyscale biz-nass
	return 'rgb('+parseInt(r)+','+parseInt(g)+','+parseInt(b)+')';
}

//Helper function for determining water coordinates on the banks of bodies of water
//a,b:{x,y}
//alt:{a,b}
//water: water level to go to
function inBetween(a,b,alt,water){
	return {x:(a.x>b.x ? b.x : a.x)+
			(Math.abs(a.x-b.x)/
				(Math.abs(alt.a-alt.b)/Math.abs(water-(alt.a>alt.b ? alt.a : alt.b)))),
			y:(a.y>b.y ? b.y : a.y)+
			(Math.abs(a.y-b.y)/
				(Math.abs(alt.a-alt.b)/Math.abs(water-(alt.a>alt.b ? alt.a : alt.b))))};
}


function inSel(point,sel){
	if(sel.a!=false && 
		point.x>=(sel.a.x<sel.b.x ? sel.a.x : sel.b.x) && 
		point.x<=(sel.a.x>sel.b.x ? sel.a.x : sel.b.x) && 
		point.y>=(sel.a.y<sel.b.y ? sel.a.y : sel.b.y) && 
		point.y<=(sel.a.y>sel.b.y ? sel.a.y : sel.b.y))
	{
		return true;
	}
	return false;
}

function buildingInSel(point,size,sel,rotation,cursor){
	var cPt;
	for(var x=0;x<size;x++){
		for(var y=0;y<size;y++){
			cPt=point.clone();
			switch(rotation){
				case 0:
					cPt.x-=x;
					cPt.y+=y;
					break;
				case 1:
					cPt.x+=x;
					cPt.y+=y;
					break;
				case 2:
					cPt.x+=x;
					cPt.y-=y;
					break;
				case 3:
					cPt.x-=x;
					cPt.y-=y;
					break;
			}
			 if((cPt.x>=(sel.a.x<sel.b.x ? sel.a.x : sel.b.x) && 
				cPt.x<=(sel.a.x>sel.b.x ? sel.a.x : sel.b.x) && 
				cPt.y>=(sel.a.y<sel.b.y ? sel.a.y : sel.b.y) && 
				cPt.y<=(sel.a.y>sel.b.y ? sel.a.y : sel.b.y))||
				(cursor.x==cPt.x && cursor.y==cPt.y))
			{
				return true;
			}
		}
	}
	return false;
	
}

function removeBuildingPlaceholders(map){
	for(var x=0;x<map.length;x++){
		for(var y=0;y<map[0].length;y++){
			delete map[x][y].buildingPlaceholderCount;
		}
	}
}



//helper for findNeighbor() to make sure there aren't cliffs in between
function whichAlts(cornerIndex){
	switch(cornerIndex){
		case 0: return {cTile:[0],oTile:[2]};
		case 1: return {cTile:[0,1],oTile:[3,2]};
		case 2: return {cTile:[1],oTile:[3]};
		case 5: return {cTile:[1,2],oTile:[0,3]};
		case 4: return {cTile:[],oTile:[]};
		case 3: return {cTile:[0,3],oTile:[1,2]};
		case 6: return {cTile:[1],oTile:[3]};
		case 7: return {cTile:[3,2],oTile:[0,1]};
		case 8: return {cTile:[2],oTile:[0]};
		
	}
}

function notCliff(altCheck,map,cTile,oTile){
	for(var i=0;i<altCheck.cTile.length;i++){
		if(map[cTile.x][cTile.y].alt[altCheck.cTile[i]]!=
			map[oTile.x][oTile.y].alt[altCheck.oTile[i]])
				return false;
	}
	return true;
}

//TODO:maybe a different notation if the neighbor is a friend?
function findNeighbor(cTile,buildingId,map,friends){
	var output=[],i=0,altCheck;
	for(var x=cTile.x-1;x<cTile.x+2;x++){
		for(var y=cTile.y-1;y<cTile.y+2;y++){
			altCheck=whichAlts(i);
			if(x>0 && x<map.length &&
				y>0 && y<map[0].length &&
				(x!=cTile.x || y!=cTile.y) &&
				notCliff(altCheck,map,cTile,{x:x,y:y}) &&
				map[x][y].buildingId &&
				map[x][y].buildingId.type &&
				(map[x][y].buildingId.type==buildingId ||
				(friends!==undefined && inArray(map[x][y].buildingId.type,friends,true))) )
			{
				output.push(map[x][y].water===false ? 1 : 2);
			}else{
				output.push(false);
			}
			i++
		}
	}
	return output;
}


function drawBuilding(map,x,y,context,cameraHeight,tileWidth,cPos,rotation,sel,offset,cursor){
	var buildingImg,bldInfo,buildTile,bldInSel,rawNeighbors,neighbors,neighborId,
		bridgeInside,bridgeOutside,bridgeAltRot,brInsideList=[],brOutsideList=[];


	//the building if there is one
	if(map[x][y].buildingId && map[x][y].buildingId.type!="placeholder")
	{
		buildTile=map[x][y];
		buildTile.buildingPlaceholderCount=(buildTile.buildingPlaceholderCount ? buildTile.buildingPlaceholderCount : 0);
		buildTile.buildingPlaceholderCount+=1;
	
	}
	if(map[x][y].buildingId && 
		map[x][y].buildingId.type && 
		map[x][y].buildingId.type=="placeholder")
	{
		buildTile=map[map[x][y].buildingId.x][map[x][y].buildingId.y];
	
		//reset if undefined or full already
		buildTile.buildingPlaceholderCount=(buildTile.buildingPlaceholderCount ? buildTile.buildingPlaceholderCount : 0);
		buildTile.buildingPlaceholderCount+=1;
	
	}
	if(buildTile && buildTile.buildingPlaceholderCount==Math.pow(getBuilding(buildTile.buildingId.type).size,2)){
		buildTile.buildingPlaceholderCount=0;
		bldInfo=getBuilding(buildTile.buildingId.type);
		bldInSel=buildingInSel({x:x,y:y},bldInfo.size,sel,rotation,cursor);
		if(bldInfo.groundImg==true){
			if(cPos[3].y<cPos[1].y && !(bldInfo.allowBridges && buildTile.bridgeAlt!==undefined)){
				//dont draw it if you cant even see it! 
				buildingImg=false;
			}else{
				if(bldInfo.neighbor){
					rawNeighbors=findNeighbor({x:x,y:y},buildTile.buildingId.type,map,bldInfo.friends);
					neighbors=rawNeighbors.boolToInt().join('');
					neighborId=neighborExists(bldInfo.neighbor,neighbors);
					if(neighborId!==false){
						neighbors="neighbor::"+neighborId+"::";
					}else{
						neighbors="";
					}
				}else{
					neighbors="";
				}

				//it may be a bridge!
				if(bldInfo.allowBridges && buildTile.bridgeAlt!==undefined){
					
					var oPos=cPos.clone(),
						cPos=tilePos(x,y,map,rotation,tileWidth,offset,cameraHeight,false,buildTile.bridgeAlt),
						inside,outside,bridgeOffset;
					//cache bridge images
					for(var i=0;i<bldInfo.bridgeSides.length;i++){
						
						if(eval("bridgeTileIndex="+buildTile.bridgeInd+";bridgeLength="+buildTile.bridgeLength+";"+bldInfo.bridgeSides[i].rel)){
							if(bldInfo.bridgeSides[i].isPylon){
								bridgeOffset=0;
								if((rawNeighbors[1] && (rotation==0 || rotation==2))||
									(rawNeighbors[3] && (rotation==1 || rotation==3))){
									inside=[{x:cPos[0].x,y:Math.round(oPos[0].y)},
											{x:cPos[3].x,y:Math.round(oPos[3].y)},
											{x:cPos[3].x,y:Math.round(cPos[3].y)},
											{x:cPos[0].x,y:Math.round(cPos[0].y)}];
									outside=[{x:cPos[1].x,y:Math.round(cPos[1].y)},
											 {x:cPos[1].x,y:Math.round(oPos[1].y)},
											 {x:cPos[2].x,y:Math.round(oPos[2].y)},
											 {x:cPos[2].x,y:Math.round(cPos[2].y)}];
									bridgeAltRot=false;
								}else{
									inside=[{x:cPos[3].x,y:Math.round(oPos[3].y)},
											{x:cPos[2].x,y:Math.round(oPos[2].y)},
											{x:cPos[2].x,y:Math.round(cPos[2].y)},
											{x:cPos[3].x,y:Math.round(cPos[3].y)}];
									outside=[{x:cPos[0].x,y:Math.round(cPos[0].y)},
											 {x:cPos[0].x,y:Math.round(oPos[0].y)},
											 {x:cPos[1].x,y:Math.round(oPos[1].y)},
											 {x:cPos[1].x,y:Math.round(cPos[1].y)}];
									bridgeAltRot=true;
								}
							}else{
								bridgeOffset=bldInfo.bridgeSides[i].vertOffset;
								//different positions based on bridge rotation
								if((rawNeighbors[1] && (rotation==0 || rotation==2))||
									(rawNeighbors[3] && (rotation==1 || rotation==3))){
									inside=[{x:cPos[0].x,y:Math.round(cPos[0].y+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											{x:cPos[3].x,y:Math.round(cPos[3].y+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											{x:cPos[3].x,y:Math.round(cPos[3].y-(bldInfo.bridgeSides[i].height*tileWidth)+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											{x:cPos[0].x,y:Math.round(cPos[0].y-(bldInfo.bridgeSides[i].height*tileWidth)+(bldInfo.bridgeSides[i].vertOffset*tileWidth))}];
									outside=[{x:cPos[1].x,y:Math.round(cPos[1].y-(bldInfo.bridgeSides[i].height*tileWidth)+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											 {x:cPos[1].x,y:Math.round(cPos[1].y+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											 {x:cPos[2].x,y:Math.round(cPos[2].y+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											 {x:cPos[2].x,y:Math.round(cPos[2].y-(bldInfo.bridgeSides[i].height*tileWidth)+(bldInfo.bridgeSides[i].vertOffset*tileWidth))}];
									bridgeAltRot=false;
								}else{
									inside=[{x:cPos[3].x,y:Math.round(cPos[3].y+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											{x:cPos[2].x,y:Math.round(cPos[2].y+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											{x:cPos[2].x,y:Math.round(cPos[2].y-(bldInfo.bridgeSides[i].height*tileWidth)+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											{x:cPos[3].x,y:Math.round(cPos[3].y-(bldInfo.bridgeSides[i].height*tileWidth)+(bldInfo.bridgeSides[i].vertOffset*tileWidth))}];
									outside=[{x:cPos[0].x,y:Math.round(cPos[0].y-(bldInfo.bridgeSides[i].height*tileWidth)+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											 {x:cPos[0].x,y:Math.round(cPos[0].y+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											 {x:cPos[1].x,y:Math.round(cPos[1].y+(bldInfo.bridgeSides[i].vertOffset*tileWidth))},
											 {x:cPos[1].x,y:Math.round(cPos[1].y-(bldInfo.bridgeSides[i].height*tileWidth)+(bldInfo.bridgeSides[i].vertOffset*tileWidth))}];
									bridgeAltRot=true;
								}
							}
							bridgeInside=getImage("bridgeSide::"+
													bldInfo.bridgeSides[i].rel+"::"+
													buildTile.buildingId.type+
													(bldInSel ? "::selected" : "")+
									  				serializeSlope(inside)+"::"+rotation);
							bridgeOutside=getImage("bridgeSide::behind::"+
													bldInfo.bridgeSides[i].rel+"::"+
													buildTile.buildingId.type+
													(bldInSel ? "::selected" : "")+
									  				serializeSlope(outside)+"::"+rotation);
							//create teh inside stretched image  				
							if(!bridgeInside){
								bridgeInside=getImage("bridgeSide::"+bldInfo.bridgeSides[i].rel+"::"+buildTile.buildingId.type+(bldInSel ? "::selected" : ""));
							
								
								stretchImage(bridgeInside,inside,2,"bridgeSide::"+
																	bldInfo.bridgeSides[i].rel+"::"+
																	buildTile.buildingId.type+
																	(bldInSel ? "::selected" : "")+
													  				serializeSlope(inside)+"::"+rotation);
								bridgeInside=false;
							}
							//create the otuside strecched image
							if(!bridgeOutside){
								//load backside specific
								bridgeOutside=getImage("bridgeSide::behind::"+bldInfo.bridgeSides[i].rel+"::"+buildTile.buildingId.type+(bldInSel ? "::selected" : ""));
								//or not...
								if(!bridgeOutside)
									bridgeOutside=getImage("bridgeSide::"+bldInfo.bridgeSides[i].rel+"::"+buildTile.buildingId.type+(bldInSel ? "::selected" : ""));
							
								stretchImage(bridgeOutside,outside,1,"bridgeSide::behind::"+
																bldInfo.bridgeSides[i].rel+"::"+
																buildTile.buildingId.type+
																(bldInSel ? "::selected" : "")+
												  				serializeSlope(outside)+"::"+rotation);
								bridgeOutside=false;
							}
							brInsideList.push({img:bridgeInside,inside:inside,offset:bridgeOffset});
							brOutsideList.push({img:bridgeOutside,outside:outside,offset:bridgeOffset});
						}
					}
					
				}

				buildingImg=getImage(neighbors+buildTile.buildingId.type+
											  (bldInSel ? "::selected" : "")+
											  serializeSlope(cPos)+"::"+rotation);
				if(!buildingImg){
					buildingImg=getImage(neighbors+buildTile.buildingId.type+
										(bldInSel ? "::selected" : ""));
										

			
					stretchImage(buildingImg,cPos,rotation,neighbors+buildTile.buildingId.type+
												  (bldInSel ? "::selected" : "")+
												  serializeSlope(cPos)+"::"+rotation);
					buildingImg=false;
				}
			}
		}else{
			if(bldInfo.boxes!==undefined){
				//draw the generated building
				buildingImg=getImage(bldInfo.id+serializeParams(buildTile.buildParams)+"::"+rotation+"::"+cameraHeight+
									(bldInSel ? "::selected" : ""));
				if(!buildingImg){
					//if we weren't able to load it, create it!
					makeBuildingSprite(bldInfo,100*bldInfo.size,rotation,cameraHeight,false,buildTile.buildParams);
				}
			}else{
				//draw a sprite for the building
				buildingImg=getImage(buildTile.buildingId.type+
									(bldInSel ? "::selected" : ""));
			}
		}
		for(var i=0;i<brOutsideList.length;i++){
			bridgeOutside=brOutsideList[i].img;
			outside=brOutsideList[i].outside;
			bridgeOffset=brOutsideList[i].offset;
			if(bridgeOutside && bridgeOutside.loaded){
				var lowestOutside=outside[0].y;
				for(var j=1;j<outside.length;j++){
					if(outside[j].y>lowestOutside) lowestOutside=outside[j].y;
				}
				context.drawImage(bridgeOutside,
								Math.round(cPos[(bridgeAltRot?0:3)].x),
								Math.round(lowestOutside-bridgeOutside.height+(bridgeOffset*tileWidth)),
								Math.round(bridgeOutside.width),
								Math.round(bridgeOutside.height));
			}
		}
		if(buildingImg && buildingImg.loaded){
			var buildingH=Math.round((buildingImg.height*bldInfo.size/
							(buildingImg.width/tileWidth)));
			context.drawImage(buildingImg,
							Math.round(cPos[3].x-(tileWidth*bldInfo.size/2)),
							Math.round(cPos[3].y-buildingH),
							Math.round(tileWidth*bldInfo.size),
							buildingH);
		}
		for(var i=0;i<brInsideList.length;i++){
			bridgeInside=brInsideList[i].img;
			inside=brInsideList[i].inside;
			bridgeOffset=brInsideList[i].offset;
			if(bridgeInside && bridgeInside.loaded){
				var lowestInside=inside[0].y;
				for(var j=1;j<inside.length;j++){
					if(inside[j].y>lowestInside) lowestInside=inside[j].y;
				}
				context.drawImage(bridgeInside,
								Math.round(cPos[(bridgeAltRot?3:0)].x),
								Math.round(lowestInside-bridgeInside.height+(bridgeOffset*tileWidth)),
								Math.round(bridgeInside.width),
								Math.round(bridgeInside.height));
			}
		}
		
	}
}

function drawGround(context,canvas,range,map,rotation,tileWidth,offset,cursor,sel,grid,cameraHeight){
	//loop through the tiles
	for(var x=range.x.start;
		(range.x.iter>0 ? x<range.x.end : x>range.x.end-1);
		x+=range.x.iter)
	{
		for(var y=range.y.start;
			(range.y.iter>0 ? y<range.y.end : y>range.y.end-1);
			y+=range.y.iter)
		{
			var cPos=tilePos(x,y,map,rotation,tileWidth,offset,cameraHeight);
			var cWater=tilePos(x,y,map,rotation,tileWidth,offset,cameraHeight,true);
			
			
			//is this tile in view?
			if((cPos[2].x>0 &&
			   cPos[1].y<canvas.height &&
			   cPos[0].x<canvas.width &&
			   cPos[3].y>0))
			{
				//draw cliffs behind ground
				var cliffPoints=[], oPos,alts=[],drawn=0,cliffColor;
				try{if((map[x+1][y].alt[0]<map[x][y].alt[3])||
					   (map[x+1][y].alt[1]<map[x][y].alt[2]))
				{
					drawn=1; //some kind of overlap?
					oPos=tilePos(x+1,y,map,rotation,tileWidth,offset,cameraHeight);
					start=(rotation==0 ? rotation : 4-rotation);
					cliffPoints=[oPos[start],
								oPos[(start+1>3 ? start+1-4 : start+1)],
								cPos[(start+2>3 ? start+2-4 : start+2)],
								cPos[(start+3>3 ? start+3-4 : start+3)]];
								
					alts=[map[x+1][y].alt[0],
						  map[x][y].alt[3],
						  map[x][y].alt[2],
						  map[x+1][y].alt[1]];
					if(inSel({x:x,y:y},sel) &&
						inSel({x:x+1,y:y},sel))
					{
						cliffColor=selFill;
					}else{
						cliffColor=groundColor(alts);
					}
					drawPath(context,cliffPoints,cliffColor);
				}}catch(err){};
				try{if(((map[x][y+1].alt[0]<map[x][y].alt[1])||
					   (map[x][y+1].alt[3]<map[x][y].alt[2]))&&
					   !(rotation==0 && drawn==1))
				{
					oPos=tilePos(x,y+1,map,rotation,tileWidth,offset,cameraHeight);
					start=(rotation==0 ? rotation : 4-rotation);
					cliffPoints=[oPos[start],
								cPos[(start+1>3 ? start+1-4 : start+1)],
								cPos[(start+2>3 ? start+2-4 : start+2)],
								oPos[(start+3>3 ? start+3-4 : start+3)]];
					alts=[map[x][y].alt[1],
						  map[x][y+1].alt[0],
						  map[x][y+1].alt[3],
						  map[x][y].alt[2]];
					if(inSel({x:x,y:y},sel) &&
						inSel({x:x,y:y+1},sel))
					{
						cliffColor=selFill;
					}else{
						cliffColor=groundColor(alts);
					}
					drawPath(context,cliffPoints,cliffColor);
				}}catch(err){};
				
				
				
				//draw the ground!
				var groundFill;
				//figure out what color to paint this tile
				if((sel.a!=false && 
					x>=(sel.a.x<sel.b.x ? sel.a.x : sel.b.x) && 
					x<=(sel.a.x>sel.b.x ? sel.a.x : sel.b.x) && 
					y>=(sel.a.y<sel.b.y ? sel.a.y : sel.b.y) && 
					y<=(sel.a.y>sel.b.y ? sel.a.y : sel.b.y))||
					(cursor.x==x && cursor.y==y)){
					//change color for selected tiles
					groundFill = selFill;
				}else{
					//normal tile color
					groundFill = groundColor(map[x][y].alt);
				}
				drawPath(context,cPos,groundFill,(grid ? gridClr : groundFill)); 
				
				//draw a building...perhaps?
				if(map[x][y].buildingId)
					drawBuilding(map,x,y,context,cameraHeight,tileWidth,cPos,rotation,sel,offset,cursor);
				
				//draw in-front cliffs
				try{if( (map[x+1][y].alt[0]>map[x][y].alt[3])||
					   (map[x+1][y].alt[1]>map[x][y].alt[2]))
				{
					oPos=tilePos(x+1,y,map,rotation,tileWidth,offset,cameraHeight);
					start=(rotation==0 ? rotation : 4-rotation);
					cliffPoints=[oPos[start],
			 					oPos[(start+1>3 ? start+1-4 : start+1)],
								cPos[(start+2>3 ? start+2-4 : start+2)],
								cPos[(start+3>3 ? start+3-4 : start+3)]];

					alts=[map[x+1][y].alt[0],
						  map[x][y].alt[3],
						  map[x][y].alt[2],
						  map[x+1][y].alt[1]];
					if(inSel({x:x,y:y},sel) &&
						inSel({x:x+1,y:y},sel))
					{
						cliffColor=selFill;
					}else{
						cliffColor=groundColor(alts);
					}
					drawPath(context,cliffPoints,cliffColor);
				}}catch(err){};
				try{if((map[x][y+1].alt[0]>map[x][y].alt[1])||
					   (map[x][y+1].alt[3]>map[x][y].alt[2]))
				{
					oPos=tilePos(x,y+1,map,rotation,tileWidth,offset,cameraHeight);
					start=(rotation==0 ? rotation : 4-rotation);
					cliffPoints=[oPos[start],
								cPos[(start+1>3 ? start+1-4 : start+1)],
								cPos[(start+2>3 ? start+2-4 : start+2)],
								oPos[(start+3>3 ? start+3-4 : start+3)]];

					alts=[map[x][y].alt[1],
						  map[x][y+1].alt[0],
						  map[x][y+1].alt[3],
						  map[x][y].alt[2]];
					if(inSel({x:x,y:y},sel) &&
						inSel({x:x,y:y+1},sel))
					{
						cliffColor=selFill;
					}else{
						cliffColor=groundColor(alts);
					}
					drawPath(context,cliffPoints,cliffColor);
				}}catch(err){};
	
				
				//draw the water
				if(cWater){
					var tilePoints=[],
						cornerOrder=[rotation,
									 (rotation+1>3 ? rotation+1-4 : rotation+1),
									 (rotation+2>3 ? rotation+2-4 : rotation+2),
									 (rotation+3>3 ? rotation+3-4 : rotation+3)];
						
					for(var i=0;i<4;i++){
						var cI=cornerOrder[i];
						//take care of any semi-banks!
						if(map[x][y].alt[cI]<=map[x][y].water){
							tilePoints.push({x:cWater[i].x, y:cWater[i].y});
						}else{
							var nextCorner=(i==3 ? 0 : i+1),
								prevCorner=(i==0 ? 3 : i-1);
							
							if(map[x][y].alt[cornerOrder[prevCorner]]<map[x][y].water) 
								tilePoints.push(inBetween(cPos[i],cPos[prevCorner],{a:map[x][y].alt[cI],b:map[x][y].alt[cornerOrder[prevCorner]]},map[x][y].water));

							if(map[x][y].alt[cornerOrder[nextCorner]]<map[x][y].water) 
								tilePoints.push(inBetween(cPos[i],cPos[nextCorner],{a:map[x][y].alt[cI],b:map[x][y].alt[cornerOrder[nextCorner]]},map[x][y].water));

						}
					}
					//draw the juice!
					drawPath(context,tilePoints,"rgba(0,0,40,0.5)");
						
				}
			}
		}
	}
	//clean up the mess
	removeBuildingPlaceholders(map);

}

function draw(map,offset,rotation,grid,sel,cursor,tileWidth,canvas,cameraHeight,showDebug){
	var context = canvas.getContext("2d"),
		range={x:{start:0,end:0,iter:1},y:{start:0,end:0,iter:1}},
		start=new Date(),end;
	tileWidth=Math.round(tileWidth);
	cameraHeight=Math.round(cameraHeight*100)/100;
	
	//clear the canvas!
	context.clearRect(0,0,canvas.width,canvas.height);

	//different z-orders for different rotations
	switch(rotation){
		case 0:
			range.x.start=0;
			range.x.end=map.length;
			range.x.iter=1;
			range.y.start=map[0].length-1;
			range.y.end=0;
			range.y.iter=-1;
			break;
		case 1:
			range.x.start=map.length-1;
			range.x.end=0;
			range.x.iter=-1;
			 range.y.start=map[0].length-1;
			range.y.end=0;
			range.y.iter=-1;
			break;
		case 2:
			range.x.start=map.length-1;
			range.x.end=0;
			range.x.iter=-1;
			range.y.start=0;
			range.y.end=map[0].length;
			range.y.iter=1;
			break;
		case 3:
			range.x.start=0;
			range.x.end=map.length;
			range.x.iter=1;
			range.y.start=0;
			range.y.end=map[0].length;
			range.y.iter=1;
			break;
			
			
	}
	
	
	//Draw each component of the view!
	drawGround(context,canvas,range,map,rotation,tileWidth,offset,cursor,sel,grid,cameraHeight);
	

	if(showDebug){
		//debug infos!
		var status='';
		//also draw the cursor pos
		if(cursor) status+='Cursor: ('+cursor.x+','+cursor.y+') Depth: '+ map[cursor.x][cursor.y].water + ' Altitude: ' + map[cursor.x][cursor.y].alt[0] + ', ' + map[cursor.x][cursor.y].alt[1] + ', ' + map[cursor.x][cursor.y].alt[2] + ', ' + map[cursor.x][cursor.y].alt[3] + ' ';
		if(cursor && 
			map[cursor.x][cursor.y].buildingId && 
			map[cursor.x][cursor.y].buildingId.type &&
			map[cursor.x][cursor.y].buildingId.type !=="placeholder")
			status+=' Neighbors: '+findNeighbor({x:cursor.x,y:cursor.y},map[cursor.x][cursor.y].buildingId.type,map,getBuilding(map[cursor.x][cursor.y].buildingId.type).friends).boolToInt().join('') +' ';
		//and the selection range
		if(sel.a) status+='Selection: ('+sel.a.x+','+sel.a.y+')'+(sel.a.x!=sel.b.x || sel.a.y!=sel.b.y ? ':('+sel.b.x+','+sel.b.y+') ' : ' ');
	
		end=new Date();
		var footStatus='ROT: ' + rotation +
						' LI: ' + loadedCount() +
						' TW: ' + tileWidth +
						' CH: ' + Math.round(cameraHeight*100) +
						' FPS: '+Math.round(10000/(end-start))/10+' ';
		context.fillStyle    = '#000';
		context.font         = 'italic 12px sans-serif';
		context.textBaseline = 'top';
		context.fillText  (footStatus, 5, canvas.height-20);
	
		if(status!=''){	
			context.fillStyle    = '#000';
			context.font         = 'italic 18px sans-serif';
			context.textBaseline = 'top';
			context.fillText  (status, 5, 5);
		}
	}
}
