function logIn(username,password,callback){
	$.post(serverPath, 
		'action=logIn'+
		'&name='+username+ 
		'&password='+password,
		function(data){
			if(data==="fail") sessionID=0;
			else sessionID=data.split(",");
			callback.call(this,data);
	});
};

function signUp(username,password,email,callback){
	$.post(serverPath,  
		'action=signUp'+
		'&name='+username+ 
		'&password='+password+
		'&email='+email,
		function(data){
			callback.call(this,data);
	});
};

function saveItem(itemName,type,category,isPublic,overWrite,contents,callback){
	$.post(serverPath,  
		'action=save'+
		'&name='+itemName+ 
		'&type='+type+ 
		'&category='+category+ 
		'&public='+isPublic+
		'&over='+overWrite+
		'&session_id='+sessionID[2]+
		'&contents='+encode64(contents),
		function(data){
			callback.call(this,data);
	});
};

function loadItem(id,callback){
	$.post(serverPath,  
	'action=load'+
	'&id='+id+
	'&session_id='+sessionID[2],
	function(data){
		callback.call(this,data);

	});
};


function deleteItem(id,callback){
	$.post(serverPath,  
		'action=delete'+
		'&id='+id+
		'&session_id='+sessionID[2],
		function(data){
			callback.call(this,data);
	
	});
};


function togglePublic(id,callback){
	
	$.post(serverPath,  
		'action=togglePublic'+
		'&id='+id+
		'&session_id='+sessionID[2],
		function(data){
			callback.call(this,data);
	
	});
};


function loadList(type,callback,cat){
	$.post(serverPath,  
		'action=list'+
		'&type='+type+
		(cat!==undefined ? '&cat='+cat : '')+
		(sessionID ? '&session_id='+sessionID[2] : ''),
		function(data){
			callback.call(this,JSON.parse(data));
			
	
	});
};


function loadCats(callback){
	var catList=[],output='';
	
	$.post(serverPath,  
		'action=listCats',
		function(data){
			//organize the trees
			function buildTree(catList,root,type) {
				var output=[],
					lastType=0,
					cItem;
					
				if(root===undefined){
					//load each type
					for(var i=0;i<catList.length;i++){
						if(catList[i].type_id!=lastType){
							//new category
							cItem={type:parseInt(catList[i].type_id),
								   id:parseInt(catList[i].id),
								   parent:parseInt(catList[i].parent_id),
								   created:catList[i].created_date}
								   
							//read this category
							cItem.children=buildTree(catList,0,cItem.type);
							
							//goto next
							lastType=cItem.type;
							output.push(cItem);
							
						}
					}
				}else{
					//load this type
					for(var i=0;i<catList.length;i++){
						if(catList[i].type_id==type && catList[i].parent_id==root){
							//new item
							cItem={name:catList[i].name,
								   id:parseInt(catList[i].id),
								   parent:parseInt(catList[i].parent_id),
								   created:catList[i].created_date,
								   userID:parseInt(catList[i].user_id)}
								   
							//read this category
							cItem.children=buildTree(catList,cItem.id,type);
							
							//goto next
							output.push(cItem);
								
						}
					}
				}

				return output;
			}
			catList=buildTree(JSON.parse(data));
			callback.call(this,catList);
			
	
	});

};


function deleteCat(id,callback){
	$.post(serverPath,  
		'action=deleteCat'+
		'&id='+id+
		'&session_id='+sessionID[2],
		function(data){
			callback.call(this,data);
	
	});
};


function saveCat(catName,parent,type,callback){
	$.post(serverPath,  
		'action=saveCat'+
		'&name='+catName+ 
		'&type='+type+ 
		'&parent='+parent+
		'&session_id='+sessionID[2],
		function(data){
			callback.call(this,data);
	});
};
