
function altBetween(x,y,range,corners){
	var out={x:x-range.x.start,
			 y:y-range.y.start},
		rangeLen={x:range.x.end-range.x.start+1,
					 y:range.y.end-range.y.start+1},
		sideVals=[((out.x/rangeLen.x)*(corners[3]-corners[0]))+corners[0],
				  ((out.x/rangeLen.x)*(corners[2]-corners[1]))+corners[1],
				  ((out.y/rangeLen.y)*(corners[1]-corners[0]))+corners[0],
				  ((out.y/rangeLen.y)*(corners[2]-corners[3]))+corners[3]];
				  
	return Math.round(sideVals.avg());
}

function avgAlt(map,sel){
	var alts=[],
		range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}};
				 
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
			alts.push(map[x][y].alt[0]);
			alts.push(map[x][y].alt[1]);
			alts.push(map[x][y].alt[2]);
			alts.push(map[x][y].alt[3]);

		}
	}
	return Math.round(alts.avg());
}

function adjustEdges(x,y,range,map){
	//adjust neighbor tile edges
	try{
		if(x==range.x.start && y==range.y.start){
			//left corner
			map[x-1][y-1].alt[2]=map[x][y].alt[0];
		}
	}catch(err){}

	try{
		if(x==range.x.start && y==range.y.end){
			//top corner
			map[x-1][y+1].alt[3]=map[x][y].alt[1];
		}
	}catch(err){}

	try{
		if(x==range.x.end && y==range.y.end){
			//right corner
			map[x+1][y+1].alt[0]=map[x][y].alt[2];
		}
	}catch(err){}

	try{
		if(x==range.x.end && y==range.y.start){
			//bottom corner
			map[x+1][y-1].alt[1]=map[x][y].alt[3];
		}
	}catch(err){}

	try{
		if(x==range.x.start){
			//left side
			map[x-1][y].alt[2]=map[x][y].alt[1];
			map[x-1][y].alt[3]=map[x][y].alt[0];
		}
	}catch(err){}

	try{
		if(x==range.x.end){
			//right side
			map[x+1][y].alt[1]=map[x][y].alt[2];
			map[x+1][y].alt[0]=map[x][y].alt[3];
		}
	}catch(err){}

	try{
		if(y==range.y.start){
			//bottom
			map[x][y-1].alt[1]=map[x][y].alt[0];
			map[x][y-1].alt[2]=map[x][y].alt[3];
		}
	}catch(err){}

	try{
		if(y==range.y.end){
			//top
			map[x][y+1].alt[0]=map[x][y].alt[1];
			map[x][y+1].alt[3]=map[x][y].alt[2];
		}
	}catch(err){}

}

function smoothSel2(map,sel,amount,doEdges,onlyDown){
	var avg=avgAlt(map,sel),
		cRange,
		range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}};
				 
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
			for(var i=0;i<4;i++){
				if(!onlyDown || map[x][y].alt[i]>avg)
					map[x][y].alt[i]+=Math.round((avg-map[x][y].alt[i])*amount);
				if(map[x][y].alt[i]<minAlt) map[x][y].alt[i]=minAlt;
				if(map[x][y].alt[i]>maxAlt) map[x][y].alt[i]=maxAlt;
			}
			
			cRange={x:{start:x, end:x},
				   y:{start:y, end:y}};
			if(doEdges) adjustEdges(x,y,range,map);
			

		}
	}
	fixWater(map);	
}

function makeMountains(map,sel){
	if(!sel.a) return false;
	var range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}},
		x=Math.round((range.x.start+range.x.end)/2),
		y=Math.round((range.y.start+range.y.end)/2),
		nextTile=0,
		cRange,
		iter=(range.x.end-range.x.start)*(range.y.end-range.y.start);
	for(var j=0;j<iter;j++){
		//move somewhere...or not
		nextTile=genRandom(0,3);
		switch(nextTile){
			case 0:
				x--;
				break;
			case 1:
				x++;
				break;
			case 2:
				y--;
				break;
			case 3:
				y++;
				break;
		}
		//wrap around if needed
		if(x>range.x.end) x=range.x.start;
		if(x<range.x.start) x=range.x.end;
		if(y>range.y.end) y=range.y.start;
		if(y<range.y.start) y=range.y.end;
		
		
		//adjust this tile
		for(var i=0;i<4;i++){
			map[x][y].alt[i]+=1;
			if(map[x][y].alt[i]<minAlt) map[x][y].alt[i]=minAlt;
			if(map[x][y].alt[i]>maxAlt) map[x][y].alt[i]=maxAlt;
		}

		cRange={x:{start:x, end:x},
			   y:{start:y, end:y}};
		adjustEdges(x,y,cRange,map);



	}
	fixWater(map);
}

function smoothSel(map,sel,doEdges){
	var range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}},
		corners=[map[range.x.start][range.y.start].alt[0],
				 map[range.x.start][range.y.end].alt[1],
				 map[range.x.end][range.y.end].alt[2],
				 map[range.x.end][range.y.start].alt[3]];
				 
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
			map[x][y].alt=[altBetween(x,y,range,corners),
							altBetween(x,y+1,range,corners),
							altBetween(x+1,y+1,range,corners),
							altBetween(x+1,y,range,corners)];
			
			if(doEdges) adjustEdges(x,y,range,map);
			

		}
	}
	fixWater(map);
}

function levelSel(map,sel,doEdges){
	var newAlt=Math.round(map[sel.a.x][sel.a.y].alt.avg()),
		range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}};
				 
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
			map[x][y].alt=[newAlt,newAlt,newAlt,newAlt];
			
			if(doEdges) adjustEdges(x,y,range,map);
			

		}
	}
	fixWater(map);
}

function changeAltitude(map,sel,amount,doEdges,minAlt,maxAlt){
	var range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}};
				  
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
			var lowAlt=false;
			
			//adjust this tile
			for(var i=0;i<4;i++){
				map[x][y].alt[i]+=amount;
				if(map[x][y].alt[i]<minAlt) map[x][y].alt[i]=minAlt;
				if(map[x][y].alt[i]>maxAlt) map[x][y].alt[i]=maxAlt;
				if(lowAlt===false || map[x][y].alt[i]<lowAlt) lowAlt=map[x][y].alt[i];
			}
			
			if(doEdges) adjustEdges(x,y,range,map);


			//turn off the water if tile is completely above it
			if(map[x][y].water!==false && lowAlt>=map[x][y].water){
				map[x][y].water=false;
			}
			
		}
		
	}
}

function fixWater(map){
	for(var x=0;x<map.length;x++){
		for(var y=0;y<map[0].length;y++){
			if(map[x][y].water!==false && lowCorner(map[x][y].alt)>=map[x][y].water)
				map[x][y].water=false;
			if(!map[x][y].buildingId)
				map[x][y].buildingId=false;
		}
	}
}

function lowCorner(corners){
	var lowAlt=false;
	
	//adjust this tile
	for(var i=0;i<4;i++){
		if(lowAlt===false || corners[i]<lowAlt) lowAlt=corners[i];
	}
	return lowAlt;

}

function findLowestSelPoint(map,sel){
	var low=false,
		range={x:{start:(sel.a.x<sel.b.x ? sel.a.x : sel.b.x),
				  end:(sel.a.x>sel.b.x ? sel.a.x : sel.b.x)},
			   y:{start:(sel.a.y<sel.b.y ? sel.a.y : sel.b.y),
				  end:(sel.a.y>sel.b.y ? sel.a.y : sel.b.y)}};
				  
	for(var x=range.x.start; x<range.x.end+1; x++){
		for(var y=range.y.start; y<range.y.end+1; y++){
			if(low===false || low.alt>lowCorner(map[x][y].alt))
				low={x:x,y:y,alt:lowCorner(map[x][y].alt)};
		}
	}
	return low;
}

function findIndent(tilePos,waterAlt,needWater,found,map){
	
	if(found==undefined) found=new Array();
	for(var x=(tilePos.x-1<0 ? 0 : tilePos.x-1);x<(tilePos.x+1+1<map.length ? tilePos.x+1+1 : map.length);x++){
		for(var y=(tilePos.y-1<0 ? 0 : tilePos.y-1);y<(tilePos.y+1+1<map[0].length ? tilePos.y+1+1 : map[0].length);y++){
			//check to see if the tile fits our indent
			if((needWater ? map[x][y].water!==false : true) && 
				(needWater ? lowCorner(map[x][y].alt)<=waterAlt : lowCorner(map[x][y].alt)<waterAlt) &&
				(!inArray({'x':x,'y':y},found))){
					found.push({'x':x,'y':y});
					found=findIndent({'x':x,'y':y},waterAlt,needWater,found,map);
			}
		}
	}
	return found;
}

function changeWaterLevel(map,sel,amount){
	var lowPoint=findLowestSelPoint(map,sel),
		lTile=map[lowPoint.x][lowPoint.y],
		newDepth=(lTile.water===false ? 
					lowCorner(lTile.alt)+amount : 
					lTile.water+amount);
	
	if(amount>0){
		var indent=findIndent(lowPoint,newDepth,false,[],map);
		for(var i=0;i<indent.length;i++){
			var cTile=map[indent[i].x][indent[i].y];
			if(lowCorner(cTile.alt)<newDepth) {
				cTile.water=newDepth;
			}
		}
	}else if(amount<0){
		var indent=findIndent(lowPoint,newDepth,true,[],map);
		for(var i=0;i<indent.length;i++){
			var cTile=map[indent[i].x][indent[i].y];
			if(cTile.water!==false && cTile.water > newDepth){
				cTile.water=newDepth;
			}
			//make sure it still is above the ground
			if(lowCorner(cTile.alt)>=newDepth) {
				cTile.water=false;
			}
		}
	
	}
	
}
