function isArray(obj) {
   if (obj.constructor.toString().indexOf("Array") == -1)
      return false;
   else
      return true;
}

function inArray(needle, haystack,notPoints) {
	var length = haystack.length;
	for(var i = 0; i < length; i++) {
		if(notPoints=='id'){
			if(haystack[i].id==needle) return true;
		}else if(notPoints){
			if(haystack[i]==needle) return true;
		}else{
			if(haystack[i].x == needle.x && haystack[i].y == needle.y) return true;
		}
	}
	return false;
}

Array.prototype.avg = function() {
var av = 0;
var cnt = 0;
var len = this.length;
for (var i = 0; i < len; i++) {
var e = +this[i];
if(!e && this[i] !== 0 && this[i] !== '0') e--;
if (this[i] == e) {av += e; cnt++;}
}
return av/cnt;
}

Array.prototype.boolToInt=function(){
	var out=[];
	for(var i=0;i<this.length;i++){
		out.push((this[i] ? 1 : 0));
	}
	return out;
}

// Array Remove - By John Resig (MIT Licensed)
Array.prototype.remove = function(from, to) {
  var rest = this.slice((to || from) + 1 || this.length);
  this.length = from < 0 ? this.length + from : from;
  return this.push.apply(this, rest);
};

Object.prototype.clone = function() {
  var newObj = (this instanceof Array) ? [] : {};
  for (i in this) {
    if (i == 'clone') continue;
    if (this[i] && typeof this[i] == "object") {
      newObj[i] = this[i].clone();
    } else newObj[i] = this[i]
  } return newObj;
};

function genRandom(from, to){
	return Math.floor(Math.random() * (to - from + 1) + from);
}

function repeatString(str,count){
	var output="";
	for(var i=0;i<count;i++){
		output+=str;
	}
	return output;
}

//Handles drawing of shapes!
function drawPath(context,tilePoints,fillStyle,strokeStyle,lineWidth){
	context.beginPath();
	if(strokeStyle) context.strokeStyle=strokeStyle;
	context.fillStyle = fillStyle;
	if(lineWidth) context.lineWidth = lineWidth;
	for(var i=0;i<tilePoints.length;i++){
		if(i==0){
			context.moveTo(Math.round(tilePoints[i].x),
							Math.round(tilePoints[i].y));
		}else{
			context.lineTo(Math.round(tilePoints[i].x),
							Math.round(tilePoints[i].y));
		}
	}


	context.fill();
	if(strokeStyle) context.stroke();
	context.closePath();
}

function neighborExists(neighbors,lookFor){
	for(var i=0;i<neighbors.length;i++){
		for(var j=0;j<neighbors[i].rel.length;j++){
			if(neighbors[i].rel[j]==lookFor) return i;
		}
	}
	return false;
}

//2 dimensional in between value
function inBetweenPts(a,b,prop){
	return {x:Math.round(a.x+((b.x-a.x)*prop)),
			y:Math.round(a.y+((b.y-a.y)*prop))};
}
/*
function inBetweenPts(a,b,prop){
	return {x:Math.round((a.x>b.x ? b.x : a.x)+(Math.abs(a.x-b.x)*prop)),
			y:Math.round(a.y+((Math.abs(a.y-b.y)*prop)*(a.y>b.y ? -1 : 1)))};
}
*/

//Sprite caching functions!
var loadedImg=[];
/*TODO: support arrays of images as srcs so that you can 
		have multiple rotations per building */
function loadImages(imgList,rotation,cameraHeight){
	var img;
	for(var i=0;i<imgList.length;i++){
		if(i=='clone') {
			continue;
		}
		if(imgList[i].loaded!==false && imgList[i].loaded!="loading" && !getImage(imgList[i].id)){
			if(imgList[i].src){
				//already have an src=ready to go
				img = new Image();
				img.onload = function(){
					this.loaded=true;
					//generate a selected image for this if it's not already one
					if(this.rel.substr(this.rel.length-10,10)!="::selected" && this.noSel!==true)
						loadTintedImage(this.rel,this,[0.5,0.5,2]);
				}
				img.rel=imgList[i].id;
				//is the src in the db?
				if(imgList[i].src.substr(0,3)=="db:"){
					loadItem(imgList[i].src.substr(3),function(data){
						img.src=data;
					});
				}else img.src = imgList[i].src;
				img.noSel=imgList[i].noSel;
				loadedImg.push({id:imgList[i].id,
								path:imgList[i].src,
								obj:img});
				if(imgList[i].neighbor){
					for(var j=0;j<imgList[i].neighbor.length;j++){
						loadImages([{id:"neighbor::"+j+"::"+imgList[i].id,
									 src:imgList[i].neighbor[j].src}]);
					}
				}
				if(imgList[i].bridgeSides){
					for(var k=0;k<imgList[i].bridgeSides.length;k++){
						loadImages([{id:"bridgeSide::"+imgList[i].bridgeSides[k].rel+"::"+imgList[i].id,
									 src:imgList[i].bridgeSides[k].src}]);
						if(imgList[i].bridgeSides[k].behindSrc){
							loadImages([{id:"bridgeSide::behind::"+imgList[i].bridgeSides[k].rel+"::"+imgList[i].id,
									 src:imgList[i].bridgeSides[k].behindSrc}]);
						}
						
					}
				}
			}else{
				//need to draw instead!
				if(rotation!==undefined && cameraHeight!==undefined){
					makeBuildingSprite(imgList[i],100*imgList[i].size,rotation,cameraHeight)
				}
			}
		}
	}
}


function getImage(id){
	for(var i=0;i<loadedImg.length;i++){
		if(loadedImg[i] && loadedImg[i].id==id){
			return loadedImg[i].obj;
		}
	}
	return false;
}

function removeImages(prefix){
	for(var i=0;i<loadedImg.length;i++){
		if(loadedImg[i] && loadedImg[i].id.substr(0,prefix.length)==prefix){
			delete loadedImg[i].obj;
			loadedImg[i]=undefined;
		}
	}
}


function loadedCount(){
	var count=0;
	for(var i=0;i<loadedImg.length;i++)
		if(loadedImg[i]!==undefined) count++;
	return count;
}


//Image manipulation functions follow!
function getPixel(imageData,pos){
	var index = (Math.round(pos.x) + Math.round(pos.y) * imageData.width) * 4;
	return [imageData.data[index+0],
			imageData.data[index+1],
			imageData.data[index+2],
			imageData.data[index+3]];
}

//color can be [r,g,b] or [r,g,b,a]
function setPixel(imageData,pos,color){
	var index = (Math.round(pos.x) + Math.round(pos.y) * imageData.width) * 4;
	imageData.data[index+0] = color[0];
	imageData.data[index+1] = color[1];
	imageData.data[index+2] = color[2];
	if(color.length>3) imageData.data[index+3] = color[3];
}

function stretchImage(cImg,cPos,rotation,loadedID,noSel){
	if(!cImg.loaded || getImage(loadedID)) return false;
	var canvas = document.createElement("canvas"),
		context = canvas.getContext("2d"),
		rotX,rotY;
	//load cImg to imageData
	canvas.width=cImg.width;
	canvas.height=cImg.height;
	context.drawImage(cImg,0,0,cImg.width,cImg.height);
	var imageData=context.getImageData(0,0,cImg.width,cImg.height);
	//figure out new size
	var minX,maxX,minY,maxY;
	for(var i=0;i<cPos.length;i++){
		if(minX===undefined || cPos[i].x<minX) minX=cPos[i].x;
		if(maxX===undefined || cPos[i].x>maxX) maxX=cPos[i].x;
		if(minY===undefined || cPos[i].y<minY) minY=cPos[i].y;
		if(maxY===undefined || cPos[i].y>maxY) maxY=cPos[i].y;
	}
	canvas.width=Math.abs(minX-maxX);
	canvas.height=Math.abs(minY-maxY);
	var stretchData=context.createImageData(canvas.width,canvas.height),
		cPt,
		xIter=(rotation==0||rotation==2 ? 1/canvas.width : 1/canvas.height),
		yIter=(rotation==0||rotation==2 ? 1/canvas.height : 1/canvas.width),
		xMax=(rotation==0||rotation==2 ? canvas.width : canvas.height),
		yMax=(rotation==0||rotation==2 ? canvas.height : canvas.width);
	
	//draw the stretched image
	//console.log('x:'+xI+' y:'+yI);
	console.log(cPos);
	for(var x=0;x<xMax+1;x++){
		for(var y=0;y<yMax+1;y++){
		cPt=inBetweenPts(inBetweenPts(cPos[0],cPos[1],x/xMax),
						 inBetweenPts(cPos[3],cPos[2],x/xMax),
						 y/yMax);
		cPt.x-=minX;
		cPt.y-=minY;
		cPt.x=Math.round(cPt.x);
		cPt.y=Math.round(cPt.y);
		rotX=x/xMax;
		rotY=y/yMax;
		switch(rotation){
			case 3:
			rotX=y/yMax;
			rotY=(xMax-x)/xMax;
			break;
			case 2:
			rotX=(xMax-x)/xMax;
			rotY=(yMax-y)/yMax;
			break;
			case 1:
			rotX=(yMax-y)/yMax;
			rotY=x/xMax;
			break;
			
		}
		//console.log('('+Math.round(imageData.width*rotX)+','+Math.round(imageData.height*rotY)+')->('+cPt.x+','+cPt.y+')');
		for(var xA=-1;xA<2;xA++){
			for(var yA=-1;yA<2;yA++){
				setPixel(stretchData,{x:cPt.x+xA,y:cPt.y+yA},
						getPixel(imageData,{x:Math.round(imageData.width*rotX),
											y:Math.round(imageData.height*rotY)}));
			}
		}
		//setPixel(stretchData,cPt,[255*(x/xMax),255*(y/yMax),255,255]);
		}
	}
	/*for(var x=0;x<1.01;x+=xIter){
		for(var y=0;y<1.01;y+=yIter){
		cPt=inBetweenPts(inBetweenPts(cPos[0],cPos[1],x),
						 inBetweenPts(cPos[3],cPos[2],x),
						 y);
		cPt.x-=minX;
		cPt.y-=minY;
		rotX=x;
		rotY=y;
		switch(rotation){
			case 3:
			rotX=y;
			rotY=1-x;
			break;
			case 2:
			rotX=1-x;
			rotY=1-y;
			break;
			case 1:
			rotX=1-y;
			rotY=x;
			break;
			
		}
		setPixel(stretchData,cPt,
				getPixel(imageData,{x:Math.round(imageData.width*rotX),
									y:Math.round(imageData.height*rotY)}));
		//setPixel(stretchData,cPt,[255*x,255*y,255,255]);
		}
	}*/
	
	
	context.putImageData(stretchData,0,0);
	loadImages([{id:loadedID,src:canvas.toDataURL(),noSel:noSel}]);
	delete canvas;
	
}

function tint(context,imageData,rgb){
	var output=context.createImageData(imageData.width,imageData.height),
		cPx;
	for(var x=0;x<imageData.width;x++){
		for(var y=0;y<imageData.height;y++){
			cPx=getPixel(imageData,{x:x,y:y});
			for(var i=0;i<3;i++){
				cPx[i]*=rgb[i];
				if(cPx[i]>255) cPx[i]=255;
				if(cPx[i]<0) cPx[i]=0;
			}
			setPixel(output,{x:x,y:y},cPx);
		}
	}
	return output;
}

function skew(context,imageData,amount){
	var newWidth=imageData.width,
		newHeight=imageData.height+Math.abs(amount*imageData.width),
		output=context.createImageData(newWidth,newHeight);
	//adjust the pixels
	for(var x=0;x<imageData.width;x++){
		if(amount>0){
			//skewing downward
			for(var y=imageData.height-1;y>-1;y--){
				setPixel(output,{x:x,y:Math.round(y+(amount*x))},
					getPixel(imageData,{x:x,y:y}));
			}
		}else{
			//skew upwards
			for(var y=0;y<imageData.height;y++){
				setPixel(output,{x:x,y:Math.round(y+Math.abs(amount*imageData.width)+(amount*x))},
					getPixel(imageData,{x:x,y:y}));
			}
			
		}
	}
	return output;
}

function drawSkewedImage(yourContext,pos,width,cImg,amount){
	if(!cImg.loaded) return false;
	var canvas = document.createElement("canvas"),
		context = canvas.getContext("2d"),
		height = cImg.height*(width/cImg.width);
	canvas.width=width;
	canvas.height=height;
	context.drawImage(cImg,0,0,width,height);
	var imageData=context.getImageData(0,0,width,height),
		skewedImg=skew(context,imageData,amount);
		
	canvas.width=skewedImg.width;
	canvas.height=skewedImg.height;
	context.clearRect(0,0,canvas.width,canvas.height);
	context.putImageData(skewedImg,0,0);
	
	var newImg=getImage("buildingGen::"+cImg.src+"::"+width+"::"+amount);
	if(newImg && newImg.loaded){
		yourContext.drawImage(newImg,pos.x,pos.y,newImg.width,newImg.height);
	}else{
		loadImages([{id:"buildingGen::"+cImg.src+"::"+width+"::"+amount,src:canvas.toDataURL()}]);
		delete canvas;
		return false;
	}

	delete canvas;
	return true;
}

function loadTintedImage(id,cImg,rgb){
	if(!cImg.loaded || getImage(id+"::selected")!==false) return false;
	var canvas = document.createElement("canvas"),
		context = canvas.getContext("2d");
	canvas.width=cImg.width;
	canvas.height=cImg.height;
	context.drawImage(cImg,0,0,cImg.width,cImg.height);
	var imageData=context.getImageData(0,0,cImg.width,cImg.height),
		tintedImg=tint(context,imageData,rgb);
	context.putImageData(tintedImg,0,0);
	loadImages([{id:id+"::selected",src:canvas.toDataURL()}]);
	delete canvas;
}


function serializeSlope(cPos){
	return "::"+Math.round(cPos[1].x-cPos[0].x)+
		   "::"+Math.round(cPos[2].x-cPos[3].x)+
		   "::"+Math.round(cPos[1].y-cPos[0].y)+
		   "::"+Math.round(cPos[2].y-cPos[3].y)+
		   "::"+Math.round(cPos[0].x-cPos[3].x)+
		   "::"+Math.round(cPos[0].y-cPos[3].y);
}

function lowestXY(cPos){
	var lowX=false,lowY=false;
	for(var i=0;i<cPos.length;i++){
		if(lowX===false || cPos[i].x<lowX) lowX=cPos[i].x;
		if(lowY===false || cPos[i].y<lowY) lowY=cPos[i].y;
	}
	return {x:lowX,y:lowY};
}


function cursorPos(cX,cY,alts,rotation,tileWidth,offset,cameraHeight){
	var range={x:{start:0,end:0,iter:1},y:{start:0,end:0,iter:1}};

	//different z-orders for different rotations
	switch(rotation){
		case 2:
			range.x.start=0;//x tile start position
			range.x.end=map.length;//x tile end position 
			range.x.iter=1;//x tile iteration [+1/-1] (typ.)
			range.y.start=map[0].length-1;
			range.y.end=0;
			range.y.iter=-1;
			break;
		case 3:
			range.x.start=map.length-1;
			range.x.end=0;
			range.x.iter=-1;
			range.y.start=map[0].length-1;
			range.y.end=0;
			range.y.iter=-1;
			break;
		case 0:
			range.x.start=map.length-1;
			range.x.end=0;
			range.x.iter=-1;
			range.y.start=0;
			range.y.end=map[0].length;
			range.y.iter=1;
			break;
		case 1:
			range.x.start=0;
			range.x.end=map.length;
			range.x.iter=1;
			range.y.start=0;
			range.y.end=map[0].length;
			range.y.iter=1;
			break;
			
			
	}
	//loop through the tiles
	for(var x=range.x.start;
		(range.x.iter>0 ? x<range.x.end : x>range.x.end-1);
		x+=range.x.iter)
	{
		for(var y=range.y.start;
			(range.y.iter>0 ? y<range.y.end : y>range.y.end-1);
			y+=range.y.iter)
	{
			var cPos=tilePos(x,y,alts,rotation,tileWidth,offset,cameraHeight);
				
			//is the cursor inside this tile?
			if(cX>cPos[0].x &&
			   cY>cPos[1].y &&
			   cX<cPos[2].x &&
			   cY<cPos[3].y)
			{
				return {x:x,y:y};	
			}	   
		}
	}
	return false;
}


