<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<title>benCity Building Generator Testerizor</title>

	<!--libraries-->
	<script src="lib/jquery-1.4.2.js"></script>
	<script src="lib/jquery-ui-1.8.5.min.js"></script>
	<script src="lib/json2.js"></script>

	<script src="genBuilding.js"></script>

	<script src="config.js"></script>
	<script src="game/server.js"></script>
	<script src="game/util.js"></script>
	<script src="game/building-gen.js"></script>

	<!--user interface-->
	<script>
	var sessionID=0;
	
	
	var curSpin,spinDown=false,curSpinTimer,
		rotation=0,zoom=100,cameraHeight=0.5,
		gotDrawn=false;

	function spin(amount){
		if(spinDown){
			var input=curSpin;
			input[0].value=parseInt(input[0].value)+amount;
			if(input.hasClass('no_zero') && input[0].value==0)
				input[0].value=(amount>0 ? 1 : -1);
			if(input.hasClass('no_negative') && input[0].value<0)
				input[0].value=0;
			if(input.hasClass('no_negative') && input.hasClass('no_zero') && input[0].value==0)
				input[0].value=1;
			curSpinTimer=setTimeout("spin("+amount+");",100);
		}
	}

	function refresh(dontClear){
		//free up old memory
		if(!dontClear){
			removeImages("buildingGen");
			gotDrawn=false;
		}
		if(!gotDrawn){
			var canvas = document.getElementById("game"),
				context = canvas.getContext("2d");
			//clear the canvas!
			context.clearRect(0,0,canvas.width,canvas.height);
			
			if(!paintBuilding(context,genBuilding,zoom,rotation,cameraHeight,{x:0,y:buildingHeight(genBuilding,zoom,cameraHeight)-(zoom*cameraHeight/2)})){
				setTimeout("refresh(true)",10);
			}else{
				gotDrawn=true;
			}
		}
	}

	jQuery(function($){
		function updateSplit(){
			var newWidth=parseInt($(this).css('left').replace("px","")),
				canvas = document.getElementById("game");
			if(newWidth<80) newWidth=80;
			if(newWidth>$(window).width()-80) newWidth=$(window).width()-80;
			$(this).css('left',newWidth);
			$("#controls").width(newWidth);
			$("#browser").width(newWidth-25);
			canvas.width =$(window).width()-newWidth-20;
			$(canvas).css("left",newWidth+10);
			refresh();
		}
	
	
		$("#controls").sortable();
		$("#splitter").draggable({axis:'x',drag:updateSplit,stop:updateSplit});
		$(".control>a").click(function(e){
			e.preventDefault();
			$(this).parent().toggleClass('minimize');
		});
	

	
		$(".spin").each(function(){
			$(this).after('<button class="spin_up">+</button><button class="spin_down">-</button>');
		});
	
		$(".control_toggle").click(function(){
			var minned=$(".control.minimize");
			if(minned.length) {
				minned.removeClass("minimize");
			} else {
				$(".control").addClass("minimize");
			}
		});
	
		$(".spin_up").live('mousedown',function(){
			clearTimeout(curSpinTimer);
			curSpin=$(this).prev();
			spinDown=true;
			spin(1);
		}).live('mouseup mouseout',function(){
			spinDown=false;
		});
		$(".spin_down").live('mousedown',function(){
			clearTimeout(curSpinTimer);
			curSpin=$(this).prev().prev();
			spinDown=true;
			spin(-1);
		}).live('mouseup mouseout',function(){
			spinDown=false;
		});
	

	
		$(window).resize(function(e){
			var canvas = document.getElementById("game");
			var controls = document.getElementById("controls");
			canvas.height=$(window).height()-20;
			$(controls).height($(window).height()-25);
			canvas.width=$(window).width()-$(controls).width()-20;
			refresh();
		}).load(function(e){$(window).resize()});
	});




	
	
	</script>
	<link rel="stylesheet" href="ui/main.css">
</head>

<body>
	<ul id="controls">

		<li class="control">
			<a href="javascript:void(0);">View</a>
			<div class="inputs">
				<label>Rotation: <input type="range" min="0" max="3" value="0" id="rotation" onchange="rotation=parseInt(this.value);refresh();"></label>
				<label>Zoom: <input type="range" min="10" max="400" value="100" onchange="zoom=parseInt(this.value);refresh();"></label>
				<label>Camera Height: <input type="range" min="5" max="100" value="50" onchange="cameraHeight=parseInt(this.value)/100;refresh();"></label>
				<label>Refresh: <button onclick="refresh();">Refresh</button></label>
			</div>
		</li>

	</ul>
	<div id="splitter">&nbsp;</div>
	<p id="browser">
		<span class="fright">Best viewed in <a href="http://www.opera.com" target="_blank">Opera</a> or <a href="http://google.com/chrome" target="_blank">Google Chrome</a>.</span>
		<a href="javascript:void(0);" class="control_toggle">Toggle Panels</a>
	</p>
	<canvas id="game" width="600" height="500"></canvas>

</body>
</html>
