<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<title>Dencity</title>

	<!--config-->
	<script src="config.js"></script>

	<!--libraries-->
	<script src="lib/jquery-1.4.2.js"></script>
	<script src="lib/jquery-ui-1.8.5.min.js"></script>
	<script src="lib/json2.js"></script>
	<script src="lib/base64.js"></script>
	<script src="lib/ajaxfileupload.js"></script>

	<!--game-->
	<script src="game/map.blank.js"></script>
	<script src="game/building-gen.js"></script>
	<script src="game/util.js"></script>
	<script src="game/draw.js"></script>
	<script src="game/terra.js"></script>
	<script src="game/construct.js"></script>
	<script src="game/server.js"></script>
	<script src="game/content.js"></script>
	<script src="game/main.js"></script>

	<!--user interface-->
	<script src="ui/ui.js"></script>
	<script src="ui/spin.js"></script>
	<script src="ui/color-picker.js"></script>
	<link rel="stylesheet" href="ui/main.css">
</head>

<body>
	<header>
		<div id="logo">Ben City</div>
		<nav>
			<form id="login">
				<label>Username: <input name="name" class="input"></label>
				<label>Password: <input name="password" class="input" type="password"></label>
				<input type="submit" value="Login" id="login_submit">
				<a href="javascript:void(0);" class="signup">Sign Up</a>
				<a href="javascript:showDialog('#plan');" class="readme">Readme</a>
			</form>
			<menu class="hidden">
				<li><span class="welcome"></span></li>
				<li><a href="javascript:void(0);" class="login">Save Map</a></li>
				<li><a href="javascript:void(0);" class="bldman">Insert Building</a></li>
				<li><a href="javascript:void(0);" class="catman">Category Manager</a></li>
				<li><a href="javascript:void(0);" class="mediaman">Media Manager</a></li>
				<li><a href="javascript:showDialog('#plan');" class="readme">Readme</a></li>
			</menu>
		</nav>
	</header>
	<ul id="controls">
		<li>
			<span class="title water_level">Water Level</span>
			<ul>
				<li><a href="javascript:changeWaterLevel(map,sel,-1);refresh();" class="lower_water icon">Lower Water Level</a></li>
				<li><a href="javascript:changeWaterLevel(map,sel,1);refresh();" class="raise_water icon">Raise Water Level</a></li>
			</ul>
		</li>
		<li>
			<span class="title terrain">Terrain</span>
			<ul>
				<li class="change_alt">
					<input type="text" id="altChange" value="1" class="spin no_zero">
					<a href="javascript:void(0);" id="change_alt" class="ok icon">Change Altitude</a>
				</li>
				
				<li><a href="javascript:void(0);" id="smooth_sel" class="flatten_terrain icon">Flatten</a></li>
				<li><a href="javascript:void(0);" id="level_sel" class="level_terrain icon">Level</a></li>
				<li><a href="javascript:makeMountains(map,sel);refresh();" class="make_mountains icon">Make Mountains</a></li>
				<li><a href="javascript:smoothSel2(map,sel,0.5,($('#altEdges')[0].value!='' ? true :false));refresh();" class="smooth_terrain icon">Smooth</a></li>
				<li><a href="javascript:smoothSel2(map,sel,0.5,($('#altEdges')[0].value!='' ? true :false),true);refresh();" class="smooth_down icon">Smooth Down</a></li>
				<li class="fix_edges"><label>Fix Edges <input type="checkbox" id="altEdges" checked></label></li>
			</ul>
		</li>
		<li>
			<a class="bldView viewType" title="View Buildings by User/Category" href="javascript:void(0);">View Buildings by User/Category</a>
			<span class="title place_buildings">Buildings</span>
			<ul id="buildings"></ul>
		</li>
		<li><a href="javascript:void(0);" id="demolish" class="demolish_sel icon">Demolish Selection</a></li>
		<li id="bldParamPanel">
			<span class="title bld_parameters">Building Parameters <a href="javascript:showDialog('#bldParamHelp');" title="Show Building Parameter Help" class="help">Help</a></span>
			<ul>
				<li><label><span>ID:</span> <select id="bldParam"></select></label></li>
				<li><label><span>Value:</span> <input type="text" id="bldParamVal" class="" value=""></label></li>
				<li><a href="javascript:void(0);" id="apply_params" class="ok icon">Apply</a></li>
				
			</ul>
		</li>
		<li>
			<span class="title new_map">New Map</span>
			<ul>
				<li><label><span>Width:</span> <input type="text" id="newMapX" class="spin no_negative no_zero" value="10"></label></li>
				<li><label><span>Height:</span> <input type="text" id="newMapY" class="spin no_negative no_zero" value="10"></label></li>
				<li><label><span>Altitude:</span> <input type="text" id="newMapAlt" class="spin no_negative" value="0"></label></li>
				<li><a href="javascript:void(0);" id="new_map" class="ok icon">Make</a></li>
			</ul>
		</li>
		<li>
			<a class="mapView viewType" title="View Maps by User/Category" href="javascript:void(0);">View Maps by User/Category</a>
			<span class="title maps">Maps</span>
			<ul id="maps"></ul>
		</li>
		<li>
			<span class="title view_opts">View <a href="javascript:showDialog('#viewHelp');" class="help" title="Show View Help">Help</a></span>
			<ul>
				<!---->
				<li class="show_grid"><label>Show Grid: <input type="checkbox" onchange="showGrid=(this.checked ? true : false);refresh();"></label></li>
				<li class="debug_info"><label>Debug Info: <input type="checkbox" onchange="showDebug=(this.checked ? true : false);refresh();" checked="checked"></label></li>
				<li><a href="javascript:mapOffset={x:50,y:150};refresh();" class="reset_offset icon">Reset to Top-Left</a></li>
			</ul>
		</li>
	</ul>
	<div id="splitter">&nbsp;</div>
	<canvas id="game" width="600" height="500"></canvas>
	<ul id="contextMenu" class="hidden">
		<li><a href="javascript:void(0);" class="centerMap">Center Map</a></li>
		<li><a href="javascript:void(0);" class="rotateLeft">Rotate Left</a></li>
		<li><a href="javascript:void(0);" class="rotateRight">Rotate Right</a></li>
	</ul>
	
	<div id="bldParamHelp" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<legend>Building Parameter Help</legend>
		<p>All buildings support a 'rotation' parameter with values 0-3.</p>
		<p>Buildings with variable 'floors' can have values 0+.</p>
		<p>Image parameters such as 'logo' point to the image file.</p>
	</div>
	<div id="viewHelp" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<legend>View Help</legend>
		<p>Hold <code>[Space]</code> to pan view. Left- or Right-click while panning to change rotation.</p>
		<p>Alternatively, use your mouse's right button to center the view at the cursor.</p>
		<p>Use your mouse's wheel to adjust zoom.</p>
		<p>Hold <code>[Ctrl]</code> and drag cursor up-down to change the camera height.</p>
	</div>
	<div id="login" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<form>
			<fieldset>
			<legend>Log In</legend>
			<label class="error_msg">Invalid Login Information!</label>
			<label>Username: <input name="name"></label>
			<label>Password: <input name="password" type="password"></label>
			<input type="submit" value="Login" id="login_submit">
			<span>New User? <a href="javascript:void(0);" class="signup">Sign Up</a></span>
			</fieldset>
		</form>
	</div>
	<div id="signup" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<form>
			<fieldset>
			<legend>Sign Up</legend>
			<label class="error_msg">Name in use!</label>
			<label>Username: <input name="name"></label>
			<label>Password: <input name="password" type="password"></label>
			<label>Email: <input name="email" type="email"></label>
			<input type="submit" value="Sign Up" id="signup_submit">
			</fieldset>
		</form>
	</div>
	<div id="mapMan" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<form>
			<fieldset>
			<legend>Save Map</legend>
			<label class="error_msg">Name in use!</label>
			<label>Name: <input name="name"></label>
			<label>Category: <select name="category" value="0"></select></label>
			<label>Public: <select name="public"><option value="0">No</option><option value="1">Yes</option></select></label>
			<label>Allow Overwrite: <select name="over"><option value="0">No</option><option value="1">Yes</option></select></label>
			<input type="submit" value="Save" id="save_submit">
			</fieldset>
		</form>
	</div>
	<div id="bldMan" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<form>
			<fieldset>
			<legend>Insert Building</legend>
			<label class="error_msg">Name in use!</label>
			<label>Name: <input name="name"></label>
			<label>Category: <select name="category"></select></label>
			<label>Contents: <textarea name="contents"></textarea></label>
			<label>Public: <select name="public"><option value="0">No</option><option value="1">Yes</option></select></label>
			<label>Allow Overwrite: <select name="over"><option value="0">No</option><option value="1">Yes</option></select></label>
			<input type="submit" value="Save" id="insert_building_submit">
			</fieldset>
		</form>
	</div>
	<div id="bldInfo" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<legend>Building Info</legend>
		<textarea class="contents"></textarea>
	</div>
	<div id="imgPreview" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<legend>Image Preview</legend>
		<div class="preview"></div>
	</div>
	<div id="catMan" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<form>
			<fieldset>
			<legend>Category Manager</legend>
			<ul id="categories" class="tree"></ul>
			<label class="error_msg">Name in use!</label>
			<h2>Insert Child Category</h2>
			<label>Name: <input name="name"></label>
			<input type="hidden" value="0" id="insert_category_parent_id" name="parent_id">
			<input type="hidden" value="2" id="insert_category_type_id" name="type_id">
			<input type="submit" value="Insert Child" id="insert_category_submit">
			</fieldset>
		</form>
	</div>
	<div id="mediaMan" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<form>
			<fieldset>
			<legend>Media Manager</legend>
			<ul id="media" class="tree"></ul>
			<div class="manager">
				<h2>Insert New Sprite</h2>
				<label class="error_msg">Name in use!</label>
				<label>Name: <input name="name"></label>
				<label>Category: <select name="category"></select></label>
				<label>File: <input id="fileToUpload" type="file" size="45" name="fileToUpload"></label>
				<label>Allow Overwrite: <select name="over"><option value="0">No</option><option value="1">Yes</option></select></label>
				<input type="submit" value="Save" id="insert_media_submit">
			</div>
			<div class="browser">
				<label>Selected Item: <input name="selID"></label>
				<input type="submit" value="Select" id="select_media_submit">
			</div>
			</fieldset>
		</form>
	</div>
	<div id="plan" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
		<legend>Readme</legend>
		<textarea class="contents">
Test Credentials-
	User: test
	Password: test

Todo (long term)-

Map the entire planet. Create the world as it is today. Figure out how to make the world more sustainable for all species.

Maybe also have some fun planets for playing around. :)

Social, political, economic, military actions between cities and groups of cities.
	Connect cities together in any way possible to create better cities.
		Governments, networks...
		
"Private" in game would mean not-user controlled.
	Only need to create a zone to start getting private buildings.
		Can be very specific to certain type of buildings
		Certain types of occupants

"Public" buildings would be able to be fully controlled by the user.
	Money would need to be raised to pay for public enterprises.
		Taxes
	Building could be owned publicly but rented to private occupants
		Subsidized rent (also for private buildings)
		
All buildings
	Have capacities for different types of occupants
	Be like an economist and allow quantified commodities to rule
	Buildings can be abandoned
	Buildings can be expanded
	There is no specific building for a specific reason anymore
	
Democratize parts of your city management
	Let the game figure it out
	Budget
	Ordinances
		Incentives to expand buildings instead of building new ones
	
Buildings classified by what you can build based on commodities available
	Educational commodities
	
Higher level city design features
	Ability to create large regions of private cities
		A zone for any buildings/any occupants
			 See what happens...
			 
		</textarea>
	</div>

	
</body>
</html>
